pro cal_050517_1565

; directory to input raw data
input_dir = '/net/koa/export/data/cbeck/obs2017/FIRS_may_2017/050517/'

; directory for output data
output_dir = '/net/koa/export/data/cbeck/obs2017/FIRS_may_2017/050517_reduced/'

; change location of save file with data information if you do not have write
; permission in input_dir [always recommended !]

change_save =  '/net/koa/export/data/cbeck/obs2017/FIRS_may_2017/050517_reduced/'

get_firs_dataprop,input_dir,change_save =change_save

; check output text file for the numbers of flat, dc, cal,
; observations before proceeding. Edit all variables with ..._files
; and/or ..._index below accordingly.


pp = 0
if pp eq 1 then begin

; location of beams along the slit. Please adjust to catch only the
; illuminated area. Current range is a bit too large for both beams.

yyrange = [4,508,512,1015]/2.

; 4 slits, 1565

firs_1083_ff,change_save = change_save,flat_file = 1,dark_file =0,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,yyrange = yyrange

; add additional ff files as needed

;firs_1083_ff,change_save = change_save,flat_file = 3,dark_file = 4,/plt,input_dir = input_dir,output_dir = output_dir,/quit_column,sspeed = .5,/pickx,yyrange = yyrange

firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,gainindex = 0,change_save =change_save ,theta_err = 3,flat_file = flat_file,retard = 116.,/quit_column,theta_pol = 0. ;,/no_av,/nopause

; add additional calibration files as needed. Set theta_pol to the
; correct value.

;firs_cal,/plt,input_dir =input_dir, output_dir = output_dir,cal_file = 5,darkindex= 0,change_save =change_save ,theta_err = 5,flat_file = flat_file,retard = 116.,/quit_column,theta_pol = 45.,/swap,/nopause

endif


pp = 1
if pp eq 1 then begin

; save file with telescope model parameters

tmat_save = '/home/cbeck/firs_soft2/Tmatrix_May2010_4708-14125.idl'

; number of calibration file, adjust as needed for each observation

cal_file = 5

wavelength = 15650.

; wavelength range for I -> QUV cross-talk removal. Set to a continuum
; wavelength window.

cont_wl = [110,120]

; position of the two spectral lines in the spectrum. Adjust as
; needed. Attention: keyword poslines superseeds
; /check_lines. 
; Suggested procedure: run first map with /check_lines, remove
; pos_lines = pos_lines,cont_wl = cont_wl. Determine the position of
; the lines, adjust pos_lines accordingly. Remove /check_lines and add
; pos_lines = pos_lines,cont_wl = cont_wl instead for all observations
; to be reduced.

pos_lines = [74,151]

firs_1565_obs,/plt,input_dir = input_dir, output_dir = output_dir,cal_file = cal_file,darkindex= 0,gainindex = 0,change_save =change_save,obsindex =  2,tmat_save = tmat_save,wavelength = wavelength,/quit_column,offang = 0.,/catch_dead,/no_align,pos_lines = pos_lines,cont_wl =cont_wl  ; /check_lines



endif


inpath = output_dir
outpath = '/export/raid1/cbeck/FIRS_archive/2017/050517/'

iinput_dir = input_dir

generate_firs_archive_files,inpath = inpath, outpath = outpath,twice = 3.,wavelen = 1565.,pollimit = .007,iinput_dir = iinput_dir

inpath = outpath
firs_create_html,filepath = inpath

outfile = '/export/raid1/cbeck/FIRS_archive/FIRS_archivemain.html'
 inpath = '/export/raid1/cbeck/FIRS_archive/'

firs_create_mainhtml,outfile = outfile,inpath = inpath


stop


end
