function crossprod,x,y

;+
;============================================================================
;
;	function : crossprod
;
;	purpose  : crossproduct between 3-dimensional vectors
;
;	written  : cbeck@KIS 06/02
;
;==============================================================================
;
;	Check number of arguments.
;
;==============================================================================
if (n_params() lt 2) then begin
	print
	print, "usage:  erg = crossprod(x,y)
	print
	print, "       Calculate crossproduct between 3-dim vectors, z=x x y."
        print
	print, "	Arguments"
        print, "                Input :"
        print, "		x,y : input vectors"
        print
        print, "                Output:"
        print, "                z = fltarr(3)"
        print
        return,0
endif
;==============================================================================
;-

z = [x(1)*y(2)-x(2)*y(1),x(2)*y(0)-x(0)*y(2),x(0)*y(1)-x(1)*y(0)]

return,z

end
