pro firs_1083_obs,plt = plt,cont_wl = cont_wl,v2q = v2q, v2u = v2u,pos_solar = pos_solar,beta = beta,obsindex = obsindex,scan_range = scan_range,smooth_width = smooth_width,spec_grad = spec_grad,verbose = verbose,fringes = fringes,gainindex = gainindex,filepath = filepath,darkindex = darkindex,cal_file = cal_file,tel_cal = tel_cal,change_save = change_save

close,/all

if n_elements(smooth_width) eq 0 then smooth_width = 1
if n_elements(filepath) eq 0 then filepath ='/export/cbeck/sir_collection/sir_gfpi_1/'

if n_elements(darkindex) eq 0 then  darkindex = 0
if n_elements(cal_file) eq 0 then  cal_file = 0
if n_elements(gainindex) eq 0 then gainindex = 0

;input_dir = '/export/cbeck/obs2013/190113/firs/'
;output_dir = '/export/cbeck/obs2013/190113/firs/reduced_190113/'

;input_dir = '/export/cbeck/obs2013/200113/firs/'
;output_dir = '/export/cbeck/obs2013/200113/firs/reduced_200113/'

;input_dir = '/export/cbeck/obs2013/210113/firs/'
;output_dir = '/export/cbeck/obs2013/210113/firs/reduced_210113/'

erg = read_directory(input_dir,filter ='*.sav')
if n_elements(change_save) ne 0 then erg = read_directory(change_save,filter ='*.sav')

outfile = erg.files
if n_elements(change_save) eq 0 then restore,input_dir+outfile(0) else restore,change_save+outfile(0)

;ilo = 180
;ihi = 230

; 16 cal   2 map  1 ff 0 dc

; 2013 01 19
types1 = [2,2,1,0,2,0,2,2,16,16,0]


; 2013 01 20

types1 = [2,1,0,2,2,1,0,2,1,0,2,16,16,2,2,1,0]


; 2013 01 21
types1 = [2,2,1,0,2,16,16,1,0,16,16,16]

; dark current
ergdc = read_directory(output_dir,filter ='*dc*')
restore,output_dir + ergdc.files(darkindex)

; gain correction
erggain = read_directory(output_dir,filter ='*gain*')
restore,output_dir + erggain.files(gainindex)
posref = mean(pposref)
oofset = fltarr(n_slits)
for k = 0,n_slits - 1 do begin & oofset(k) = mean(pposref(k,*,*)) - mean(pposref(0,*,*)) & endfor

if n_elements(fringes) ne 0 then begin
   ergfringe = read_directory(output_dir,filter ='*fringe*')
   fringefile = output_dir + ergfringe.files(gainindex)
endif

; calibration data
calbasefile = bbasefile1(cal_file)  

outfile1 = output_dir+'xmat.'+calbasefile+'sav'
restore,outfile1

xxinv = xxmat - xxmat
for k = 0,n_slits-1 do begin
 
 xmat = reform(xxmat(k,*,*))
 xmat(0,*) = xmat(0,*)+1

 normaliza=max(xmat(0,*))
 xmat(0,*)=xmat(0,*)/normaliza
for i=1,3 do begin & xmat(i,*)=xmat(i,*)*xmat(0,*) & endfor
 dmod=invert(xmat,/double)
 dmod = transpose(dmod)
 xmat = transpose(xmat)
 for i=0,3 do begin & dmod(*,i)=dmod(*,i)*xmat(i,0) & endfor
 dmod = transpose(dmod)
 xxmat(k,*,*) = xmat
 xxinv(k,*,*) = dmod

endfor

;if n_elements(cont_wl) eq 0 then cont_wl = [180,210]
;if n_elements(pos_solar) eq 0 then pos_solar = [0,dx_final]

if n_elements(obsindex) eq 0 then obsindex = 0
obsbasefile = bbasefile1(obsindex)
ergobs = read_directory(input_dir,filter ='*'+obsbasefile+'*')
obsfiles = ergobs.files

nsteps = n_elements(obsfiles)
;outfile = output_dir +obsbasefile+'reduced.dat'
outfile = output_dir +obsbasefile+'reduced_nofringe.dat'

;outfile = '/home/cbeck/firs/result/'+obsbasefile+'reduced.dat'

outfile2 = outfile+'.sav'

if n_elements(scan_range) eq 0 then scan_range = [0,nsteps-1]

nsteps_total = scan_range(1)-scan_range(0)+1.

sshifts = fltarr(n_slits,nsteps_total,2)
llinepos = fltarr(n_slits,nsteps_total,2)

ic = fltarr(nsteps_total*n_slits,dy_final+1)
totq = fltarr(nsteps_total*n_slits,dy_final+1)
totu = fltarr(nsteps_total*n_slits,dy_final+1)
totv = fltarr(nsteps_total*n_slits,dy_final+1)

if n_elements(plt) ne 0 then begin


   if dx_final lt 800 then begin

   for k = 0,n_slits -1 do begin & window,k,xs = 4*dx_final,ys = 500,title = 'Stokes spectra slit '+num2string(k) & endfor

   endif else begin
   for k = 0,n_slits -1 do begin & window,k,xs = 2*dx_final,ys = 2*500,title = 'Stokes spectra slit '+num2string(k) & endfor
            
   endelse


window,4,xs = n_slits*nsteps_total*2,ys = 600,title = '2D maps'

endif


erg = 0.
erg1 = 0.

openw,outunit,outfile,/get_lun

for k = scan_range(0),scan_range(1) do begin

   oldt = systime(1)


 fxread,input_dir+obsfiles(k),dum,hdr
 
 ee = size(dum)
 if ee(0) ne 3 then begin
    ddum = fltarr(ee(1),ee(2),4)
    ddum(*,*,0) = dum
    ddum(*,*,1) = dum
    ddum(*,*,2) = dum
    ddum(*,*,3) = dum
    dum = ddum
 endif


 dum = dum - dc

;dum = ff_img -dc

 ;  getiquv,dum,ii,qq,uu,vv
 
 ibeams = fltarr(n_slits,2,dx+1,dy+1,4)

;for kk = 0,n_slits-1 do begin &  ii_temp = rot(reform(dum(*,*,0)),aangle(kk),/interp) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = rot(reform(dum(*,*,1)),aangle(kk),/interp) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = rot(reform(dum(*,*,2)),aangle(kk),/interp) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = rot(reform(dum(*,*,3)),aangle(kk),/interp) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

for kk = 0,n_slits-1 do begin &  ii_temp = reform(dum(*,*,0)) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = reform(dum(*,*,1)) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = reform(dum(*,*,2)) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = reform(dum(*,*,3)) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

;img1 = ibeams


 ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

;img2 = ibeams1

 for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk) /gaintable(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk) / gaintable(kk,1,*,*,kkk)  & endfor & endfor

if n_elements(fringes) eq 27 then begin

  ii = reform(ibeams1(0,0,*,*,0))

  tip_x = 0.
  tip_y = 0.
  model_num = 73.
  disp = 5.5
  prof_type = 3
  lineindex = [3,5]
 
  infile = filepath+'prof.per'
   

  llineindex = intarr(dx_final+1)+3
  n_tot = dx_final + 1
  xx = findgen(dx_final+1) 

for kk = 0,n_slits-1 do begin & for kkk = 0,3 do begin & ff = reform(total(ibeams1(kk,0,*,*,kkk),4)) & erg = poly_fit(xx,ff(xx),3,/double) & yy = erg(0)+erg(1)*findgen(dx_final+1)+erg(2)*findgen(dx_final+1)^2.+erg(3)*findgen(dx_final+1)^3. & yy = yy / mean(yy) & for kkkk = 0,dy_final do begin & ibeams1(kk,0,*,kkkk,kkk) = ibeams1(kk,0,*,kkkk,kkk) / yy & endfor  & ff = reform(total(ibeams1(kk,1,*,*,kkk),4)) & xx = findgen(dx_final+1) & erg = poly_fit(xx,ff(xx),3,/double) & yy = erg(0)+erg(1)*findgen(dx_final+1)+erg(2)*findgen(dx_final+1)^2.+erg(3)*findgen(dx_final+1)^3. & yy = yy / mean(yy) & for kkkk = 0,dy_final do begin & ibeams1(kk,1,*,kkkk,kkk) = ibeams1(kk,1,*,kkkk,kkk) / yy & endfor & endfor & endfor

   cd,filepath

   fringe_corr = fltarr(n_slits,2,4,dx_final+1)

 for kk = 0,n_slits-1 do begin & for kkk = 0,3 do begin &  ii = reform(ibeams1(kk,0,*,*,kkk)) & iic = mean(ii(120:130,*)) & ii = ii / iic & wavel = 1564.8515 + (findgen(dx_final+1)-pposref(kk,0,kkk))*disp/1000. & wavel = wavel*10. - 15648.515 & wavel = wavel*1000. & wavel = round(wavel(0))+ findgen(dx_final+1)*disp*10. & write_sir_grid_firs,filepath+'wavelength.grid',lineindex,wavel(0),wavel(dx_final),disp*10.,/blend & i = total(ii,2)/float(dy_final+1.) & q = i -i  & u = i -i  & v = i -i & write_sir_profiles,infile,llineindex,wavel,i,q,u,v & perform_inversion_laptop,filepath,i_fit,q_fit,u_fit,v_fit,n_tot,model_num,model,model1,model2,firstline1,firstline2,prof_type,1,error_status,tip_x,tip_y,/quiet & fringe_corr(kk,0,kkk,*) = i/i_fit &  ii = reform(ibeams1(kk,1,*,*,kkk)) & iic = mean(ii(120:130,*)) & ii = ii / iic & wavel = 1564.8515 + (findgen(dx_final+1)-pposref(kk,0,kkk))*disp/1000. & wavel = wavel*10. - 15648.515 & wavel = wavel*1000. & wavel = round(wavel(0))+ findgen(dx_final+1)*disp*10. & write_sir_grid_firs,filepath+'wavelength.grid',lineindex,wavel(0),wavel(dx_final),disp*10.,/blend & i = total(ii,2)/float(dy_final+1.) & q = i -i  & u = i -i  & v = i -i & write_sir_profiles,infile,llineindex,wavel,i,q,u,v & perform_inversion_laptop,filepath,i_fit,q_fit,u_fit,v_fit,n_tot,model_num,model,model1,model2,firstline1,firstline2,prof_type,1,error_status,tip_x,tip_y,/quiet & fringe_corr(kk,1,kkk,*) = i/i_fit & print,kk,kkk & endfor & endfor

max_range = 13.

 for kk = 0,n_slits-1 do begin & for kkk = 0,3 do begin & ii = reform(fringe_corr(kk,0,kkk,*)) & erg = fft(ii,-1) & erg1 = erg-erg & erg1(0:max_range,*) = erg(0:max_range,*) & erg1(dx_final-max_range:dx_final,*) = erg(dx_final-max_range:dx_final,*) & ccorr = (ii-fft(erg1,1))+1. & ii = reform(ibeams1(kk,0,*,*,kkk)) & for kkkk = 0,dy_final do begin & ii(*,kkkk) = ii(*,kkkk)/ccorr & endfor & ibeams1(kk,0,*,*,kkk) = ii & ii = reform(fringe_corr(kk,1,kkk,*)) & erg = fft(ii,-1) & erg1 = erg-erg & erg1(0:max_range,*) = erg(0:max_range,*) & erg1(dx_final-max_range:dx_final,*) = erg(dx_final-max_range:dx_final,*) & ccorr = (ii-fft(erg1,1))+1. & ii = reform(ibeams1(kk,1,*,*,kkk)) & for kkkk = 0,dy_final do begin & ii(*,kkkk) = ii(*,kkkk)/ccorr & endfor & ibeams1(kk,1,*,*,kkk) = ii & endfor & endfor

;restore,fringefile
;for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk) * fringe_corr(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk) * fringe_corr(kk,1,*,*,kkk)  & endfor & endfor

endif

 for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  rot(reform(ibeams1(kk,0,*,*,kkk)),aangle(kk),/interp) & ibeams1(kk,1,*,*,kkk) =  rot(reform(ibeams1(kk,1,*,*,kkk)),aangle(kk),/interp)  & endfor & endfor

;xx = findgen(dx_final + 1)
;xx = xx/180.*!pi

;n_per = 24.  
;weights = fltarr(dx_final+1)+1.
 
;a = [n_per,-0.8,.1,1]
   
;corr = gaintable - gaintable
;aout = fltarr(n_slits,2,dy_final+1,4,4)
;for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ii = reform(ibeams1(kk,0,*,*,kkk)) & ii1 = ii/smooth(ii,19,/edge_truncate) & y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a & for kkkk = 0.,dy_final do begin & y = reform(ii1(*,kkkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [0,1,1,1]) & aout(kk,0,kkkk,kkk,*) = a & corr(kk,0,*,kkkk,kkk) = erg & endfor & ii = reform(ibeams1(kk,1,*,*,kkk)) & ii1 = ii/smooth(ii,19,/edge_truncate) &y = total(ii1,2)/(dy_final+1.) & a = [n_per,-0.8,.1,1] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.)) & aini = a &  for kkkk = 0.,dy_final do begin & y = reform(ii1(*,kkkk)) & a = aini & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.),fita = [0,1,1,1]) & aout(kk,1,kkkk,kkk,*) = a   & corr(kk,1,*,kkkk,kkk) = erg & endfor & endfor & endfor
;for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk) /corr(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk) /corr(kk,1,*,*,kkk)  & endfor & endfor

;ilobes = [90,160]
;  for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ii = reform(ibeams1(kk,0,*,*,kkk)) & ii1 = ii/smooth(ii,19,/edge_truncate)  & y = total(ii1,2)/(dy_final+1.)  & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.))  & aini = a  & weights(ilobes(0)-20+oofset(kk):ilobes(0)+20+oofset(kk)) = 0. & weights(ilobes(1)-20+oofset(kk):ilobes(1)+20+oofset(kk)) = 0. & corr = ii - ii & aa = fltarr(12,dy_final+1) & for kkkk = 0,dy_final do begin & y = reform(ii1(*,kkkk)) & a = [aini(0),0.00,0.00,aini(1),0.001,0.00,aini(2),0.0000,0.0000,aini(3),0.1,0.000] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var_1',/double,itmax = 50,tol = 10^(-4.),fita = [1,0,0,1,1,0,1,0,0,1,1,0]) & aa(*,kkkk) = a & corr(*,kkkk) = erg & endfor & aa(9,*) = 1.  & corr1 = ii - ii & for kkkk = 0,dy_final do begin & sin_var_1,xx,reform(aa(*,kkkk)),f & corr1(*,kkkk) = f & endfor & ii = ii/corr1 &  ibeams1(kk,0,*,*,kkk) = ii & ii = reform(ibeams1(kk,1,*,*,kkk)) & ii1 = ii/smooth(ii,19,/edge_truncate)  & y = total(ii1,2)/(dy_final+1.)  & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.))  & aini = a  & weights(ilobes(0)-20+oofset(kk):ilobes(0)+20+oofset(kk)) = 0. & weights(ilobes(1)-20+oofset(kk):ilobes(1)+20+oofset(kk)) = 0. & corr = ii - ii & aa = fltarr(12,dy_final+1) & for kkkk = 0,dy_final do begin & y = reform(ii1(*,kkkk)) & a = [aini(0),0.00,0.00,aini(1),0.001,0.00,aini(2),0.0000,0.0000,aini(3),0.1,0.000] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var_1',/double,itmax = 50,tol = 10^(-4.),fita = [1,0,0,1,1,0,1,0,0,1,1,0]) & aa(*,kkkk) = a & corr(*,kkkk) = erg & endfor & aa(9,*) = 1.  & corr1 = ii - ii & for kkkk = 0,dy_final do begin & sin_var_1,xx,reform(aa(*,kkkk)),f & corr1(*,kkkk) = f & endfor & ii = ii/corr1 &  ibeams1(kk,1,*,*,kkk) = ii & endfor & endfor
;endif




if ( (k-scan_range(0))) eq 0 then begin
 ; determine location of spectral lines
 iline = total(reform(ibeams1(0,0,*,*,0)),2)
 iline = abs(iline/float(max(iline))-1)
 
 n = length(iline)
 ilobes = fltarr(n-4)
 threshh = .2
 ilobeindex = 0.
 for kkk = 5,n-5 do begin
 if iline(kkk) gt max(iline(kkk+1:kkk+4)) and iline(kkk) gt max(iline(kkk-4:kkk-1)) and iline(kkk) gt threshh then begin
 ilobes(ilobeindex) = kkk
 ilobeindex = ilobeindex+1
endif
 endfor

 if n_elements(verbose) ne 0 then print,ilobeindex,' spectral lines found.'

 wdel17 = 0.

 if ilobeindex ne 2 then begin
 print,' Automatic detection of spectral lines failed.'
 print,' Please select lines manually:'
 wdel17 = 1.
 window,17
 !p.multi = 0
 plot,iline 
 ilobeindex = 0.
 ilobes = fltarr(n-4)
 while ilobeindex ne 2 do begin
 wset,17
                    cursor,x,y,/data,/wait
                    if !mouse.button eq 1 then begin
                        ilobes(ilobeindex) = x
                        ilobeindex = ilobeindex+1
                        print,'Line ',ilobeindex
                        print,'at ',x
                        oplot,[x,x],[0,1]
                        wait,.5
                    endif
                    if ilobeindex eq 2 then begin
                        ans = read_keyboard('Selection okay y(es)/n(o) ')
                        if ans eq 'n' then begin
                            ilobeindex = 0
                            plot,iline    
                        endif
                    endif
                endwhile
            endif
            ilobes = ilobes(0:ilobeindex-1)
            ilobes = ilobes(sort(ilobes))
            
            range_telu = [-15,15]+ilobes(1)

            ilo = range_telu(0)
            ihi = range_telu(1)

            if n_elements(pos_solar) eq 0 then pos_solar = [ilobes(0)-30,ilobes(0)+30.]
            if n_elements(cont_wl) eq 0 then cont_wl = [ilobes(0)+30,ilobes(1)-30]


        ;    wave_lim = [ilobes(0)-30,ilobes(2)+10,2]
         endif



;xx = [ilobes(0)-80+findgen(40),ilobes(1)-25+findgen(12),ilobes(1)+12+findgen(12),ilobes(3)+10+findgen(35)]

if n_elements(spec_grad) ne 0 then begin

for kk = 0,n_slits-1 do begin & for kkk = 0,1 do begin & for kkkk = 0,3 do begin & ii = reform(ibeams1(kk,kkk,*,*,kkkk)) & for kkkkk = 0,dy_final do begin & iline = reform(ii(*,kkkkk)) & ergg = poly_fit(xx+oofset(kk),iline(xx+oofset(kk)),4,/double) & yy = ergg(0)+ergg(1)*findgen(dx_final+1)+ergg(2)*findgen(dx_final+1)^2.+ergg(3)*findgen(dx_final+1)^3.+ergg(4)*findgen(dx_final+1)^4. & yy = yy /mean(yy) & iline = iline / yy & ii(*,kkkkk) = iline & endfor & ibeams1(kk,kkk,*,*,kkkk) = ii & endfor & endfor & endfor 

endif



;stop

;deskew1,i1,dummy,dummy,dummy,ilo+oofset(kk),ihi+oofset(kk),0,dy_final,0,dy_final,3,/third_order & deskew1,i2,dummy,dummy,dummy,ilo+oofset(kk),ihi+oofset(kk),0,dy_final,0,dy_final,3,/third_order 

pp = 0
if pp eq 1 then begin
 for kk = 0,n_slits -1 do begin & for kkk = 0,3 do begin & i1 = reform(ibeams1(kk,0,*,*,kkk)) & i2 = reform(ibeams1(kk,1,*,*,kkk)) & dummy = i1-i1 & if kkk eq 0 then erg = shc(i1(50:dx_final-50,50:dy_final-50),i2(50:dx_final-50,50:dy_final-50),/filt,/interp)  & if total(abs(erg)) lt 2 then i2 = shift_frac(i2,0,erg(1),'C')  & if kkk eq 0 and n_elements(verbose) ne 0 then print,erg & ibeams1(kk,1,*,*,kkk) = i2 & if kkk eq 0 then sshifts(kk,k-scan_range(0),*) = erg & ibeams1(kk,0,*,*,kkk) = i1 &  endfor & endfor

poslines = fltarr(n_slits,2,dy_final+1,4)
for kk = 0,n_slits -1 do begin & for kkk = 0,3 do begin & for kkkkk = 0,1 do begin & i1 = reform(ibeams1(kk,kkkkk,*,*,kkk)) & for kkkk = 0,dy_final do begin & iline = reform(i1(*,kkkk)) & ergg = min(iline(ilo+oofset(kk):ihi+oofset(kk)),posmin) & lpff,iline(posmin+ilo+oofset(kk)-5:posmin+ilo+oofset(kk)+5),ppos & poslines(kk,kkkkk,kkkk,kkk) = ppos+posmin+ilo+oofset(kk)-5 & endfor & endfor & endfor & endfor


for kk =  0,n_slits -1 do begin & ref_curve = reform(poslines(kk,0,*,0)) & for kkk = 0,1 do begin & for kkkk = 0,3 do begin & ccurve = reform(poslines(kk,kkk,*,kkkk)) & diff = ref_curve - ccurve &  ergg = poly_fit(findgen(dy_final+1),diff,2,/double) &  yy = 0. & for oo = 0.,2 do begin & yy = yy + findgen(dy_final+1)^float(oo)*ergg(oo) & endfor & i1 = reform(ibeams1(kk,kkk,*,*,kkkk)) & sshift_img,i1,yy,0,dy_final-1 & ibeams1(kk,kkk,*,*,kkkk) = i1 & endfor& endfor& endfor


poslines = fltarr(n_slits,2,dy_final+1,4)
for kk = 0,n_slits -1 do begin & for kkk = 0,3 do begin & for kkkkk = 0,1 do begin & i1 = reform(ibeams1(kk,kkkkk,*,*,kkk)) & for kkkk = 0,dy_final do begin & iline = reform(i1(*,kkkk)) & ergg = min(iline(ilo+oofset(kk):ihi+oofset(kk)),posmin) & lpff,iline(posmin+ilo+oofset(kk)-5:posmin+ilo+oofset(kk)+5),ppos & poslines(kk,kkkkk,kkkk,kkk) = ppos+posmin+ilo+oofset(kk)-5 & endfor & endfor & endfor & endfor

for kk = 0,n_slits -1 do begin & llinepos(kk,k-scan_range(0),0) = mean(poslines(kk,0,*,0)) & llinepos(kk,k-scan_range(0),1) = mean(poslines(kk,1,*,0)) & endfor

endif


   ibeams_merged =  fltarr(n_slits,dx_final+1,dy_final+1,4)

   for kk = 0,n_slits -1 do begin
      xinv = reform(xxinv(kk,*,*))
      dmod = xinv

; ii = reform(ibeams_merged(kk,*,*,0))
;      qq = reform(ibeams_merged(kk,*,*,1))
;      uu = reform(ibeams_merged(kk,*,*,2))
;      vv = reform(ibeams_merged(kk,*,*,3))


im1a = reform(ibeams1(kk,0,*,*,0))
im2a = reform(ibeams1(kk,0,*,*,1))
im3a = reform(ibeams1(kk,0,*,*,2))
im4a = reform(ibeams1(kk,0,*,*,3))

im1b = reform(ibeams1(kk,1,*,*,0))
im2b = reform(ibeams1(kk,1,*,*,1))
im3b = reform(ibeams1(kk,1,*,*,2))
im4b = reform(ibeams1(kk,1,*,*,3))

if smooth_width gt 1 then begin
  ; spike correction
      ff1a = total(im1a(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
      ff2a = total(im2a(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
      ff3a = total(im3a(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
      ff4a = total(im4a(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
      ff1b = total(im1b(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
      ff2b = total(im2b(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
      ff3b = total(im3b(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
      ff4b = total(im4b(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)

      corr1a = ff1a / smooth(ff1a,smooth_width)
      corr2a = ff2a / smooth(ff2a,smooth_width)
      corr3a = ff3a / smooth(ff3a,smooth_width)
      corr4a = ff4a / smooth(ff4a,smooth_width)
      corr1b = ff1b / smooth(ff1b,smooth_width)
      corr2b = ff2b / smooth(ff2b,smooth_width)
      corr3b = ff3b / smooth(ff3b,smooth_width)
      corr4b = ff4b / smooth(ff4b,smooth_width)
 
     
       for kkk = 0,dx_final do begin &  im1a(kkk,*) =  im1a(kkk,*) / corr1a  &im2a(kkk,*) =  im2a(kkk,*) / corr2a  &im3a(kkk,*) =  im3a(kkk,*) / corr3a  &im4a(kkk,*) =  im4a(kkk,*) / corr4a  & im1b(kkk,*) =  im1b(kkk,*) / corr1b  & im2b(kkk,*) =  im2b(kkk,*) / corr2b  & im3b(kkk,*) =  im3b(kkk,*) / corr3b  &im4b(kkk,*) =  im4b(kkk,*) / corr4b & endfor
endif




      i1a  = dmod(0,0)*im1a+dmod(1,0)*im2a+dmod(2,0)*im3a+dmod(3,0)*im4a
      i2a  = dmod(0,1)*im1a+dmod(1,1)*im2a+dmod(2,1)*im3a+dmod(3,1)*im4a
      i3a  = dmod(0,2)*im1a+dmod(1,2)*im2a+dmod(2,2)*im3a+dmod(3,2)*im4a
      i4a  = dmod(0,3)*im1a+dmod(1,3)*im2a+dmod(2,3)*im3a+dmod(3,3)*im4a
      
      i1b  = dmod(0,0)*im1b+dmod(1,0)*im2b+dmod(2,0)*im3b+dmod(3,0)*im4b
      i2b  = dmod(0,1)*im1b+dmod(1,1)*im2b+dmod(2,1)*im3b+dmod(3,1)*im4b
      i3b  = dmod(0,2)*im1b+dmod(1,2)*im2b+dmod(2,2)*im3b+dmod(3,2)*im4b
      i4b  = dmod(0,3)*im1b+dmod(1,3)*im2b+dmod(2,3)*im3b+dmod(3,3)*im4b

      ii1 = (i1a+i1b)/2.

;      ii1 = (i1a+i1a)/2.
;     ii1 = (i1b+i1b)/2.
      qq1 = (i2a-i2b)/2.
      uu1 = (i3a-i3b)/2.
      vv1 = (i4a-i4b)/2.




      ff = where(ii1 lt 0)
      if ff(0) ne -1 then ii1(ff) = 0.


     ; ii1  = xinv(0,0)*ii+xinv(1,0)*qq+xinv(2,0)*uu+xinv(3,0)*vv
     ; qq1  = xinv(0,1)*ii+xinv(1,1)*qq+xinv(2,1)*uu+xinv(3,1)*vv
     ; uu1  = xinv(0,2)*ii+xinv(1,2)*qq+xinv(2,2)*uu+xinv(3,2)*vv
     ; vv1  = xinv(0,3)*ii+xinv(1,3)*qq+xinv(2,3)*uu+xinv(3,3)*vv

      ibeams_merged(kk,*,*,0) = ii1
      ibeams_merged(kk,*,*,1) = qq1
      ibeams_merged(kk,*,*,2) = uu1
      ibeams_merged(kk,*,*,3) = vv1

  

   endfor


if n_elements(fringes) ne 0 then begin

  tip_x = 0.
  tip_y = 0.
  model_num = 73.
  disp = 5.5
  prof_type = 3
  lineindex = [3,5]
 
  infile = filepath+'prof.per'
   

  llineindex = intarr(dx_final+1)+3
  n_tot = dx_final + 1
  xx = findgen(dx_final+1) 

for kk = 0,n_slits-1 do begin & ii = reform(ibeams_merged(kk,*,*,0)) &  ff = total(ii,2) & erg = poly_fit(xx,ff(xx),3,/double) & yy = erg(0)+erg(1)*findgen(dx_final+1)+erg(2)*findgen(dx_final+1)^2.+erg(3)*findgen(dx_final+1)^3. & yy = yy / mean(yy) & for kkk = 0,dy_final do begin & ibeams_merged(kk,*,kkk,0) = ibeams_merged(kk,*,kkk,0)/ yy & ibeams_merged(kk,*,kkk,1) = ibeams_merged(kk,*,kkk,1)/ yy & ibeams_merged(kk,*,kkk,2) = ibeams_merged(kk,*,kkk,2)/ yy & ibeams_merged(kk,*,kkk,3) = ibeams_merged(kk,*,kkk,3)/ yy & endfor  & endfor

   cd,filepath

   fringe_corr = fltarr(n_slits,dx_final+1)

for kk = 0,n_slits-1 do begin &   ii = reform(ibeams_merged(kk,*,*,0)) & iic = mean(ii(120:130,*)) & ii = ii / iic & wavel = 1564.8515 + (findgen(dx_final+1)-pposref(kk,0,0))*disp/1000. & wavel = wavel*10. - 15648.515 & wavel = wavel*1000. & wavel = round(wavel(0))+ findgen(dx_final+1)*disp*10. & write_sir_grid_firs,filepath+'wavelength.grid',lineindex,wavel(0),wavel(dx_final),disp*10.,/blend & i = total(ii,2)/float(dy_final+1.) & q = i -i  & u = i -i  & v = i -i & write_sir_profiles,infile,llineindex,wavel,i,q,u,v & perform_inversion_laptop,filepath,i_fit,q_fit,u_fit,v_fit,n_tot,model_num,model,model1,model2,firstline1,firstline2,prof_type,1,error_status,tip_x,tip_y,/quiet & fringe_corr(kk,*) = i/i_fit & print,kk & endfor

;stop
;ii_temp = ibeams_merged -ibeams_merged

max_range = 10.
for kk = 0,n_slits-1 do begin & ii = reform(fringe_corr(kk,*)) & erg = fft(ii,-1) & erg1 = erg-erg & erg1(0:max_range,*) = erg(0:max_range,*) & erg1(dx_final-max_range:dx_final,*) = erg(dx_final-max_range:dx_final,*) & ccorr = (ii-fft(erg1,1))+1. & ii = reform(ibeams_merged(kk,*,*,0)) & qq = reform(ibeams_merged(kk,*,*,1)) & uu = reform(ibeams_merged(kk,*,*,2)) & vv = reform(ibeams_merged(kk,*,*,3)) & for kkkk = 0,dy_final do begin & ii(*,kkkk) = ii(*,kkkk)/ccorr  & qq(*,kkkk) = qq(*,kkkk)/ccorr  & uu(*,kkkk) = uu(*,kkkk)/ccorr  & vv(*,kkkk) = vv(*,kkkk)/ccorr & endfor & ibeams_merged(kk,*,*,0) = ii  & ibeams_merged(kk,*,*,1) = qq  & ibeams_merged(kk,*,*,2) = uu  & ibeams_merged(kk,*,*,3) = vv & endfor

;ii_temp(kk,*,*,0) = ii & endfor



;   n_per = 24.  
;   xx = findgen(dx_final + 1)
;   xx = xx/180.*!pi
;   weights = fltarr(dx_final+1)+1.
;   a = [n_per,-0.8,.1,1]
 
 ; for kk = 0,n_slits -1 do begin & ii = reform( ibeams_merged(kk,*,*,0)) & ii1 = ii/smooth(ii,19,/edge_truncate)  & y = total(ii1,2)/(dy_final+1.)  &  a = [n_per,-0.8,.1,1] &  weights = fltarr(dx_final+1)+1. & weights(ilobes(0)-10+oofset(kk):ilobes(0)+10+oofset(kk)) = 0. & weights(ilobes(1)-10+oofset(kk):ilobes(1)+10+oofset(kk)) = 0. & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var',/double,itmax = 50,tol = 10^(-4.))  & aini = a   & corr = ii - ii & aa = fltarr(12,dy_final+1) & for kkkk = 0,dy_final do begin & y = reform(ii1(*,kkkk)) & a = [aini(0),0.000,0.00,aini(1),0.001,0.00,aini(2),0.0000,0.0000,aini(3),0.001,0.000] & erg = curvefit(xx,y,weights,a,/noderivative,function_name='sin_var_1',/double,itmax = 50,tol = 10^(-4.),fita = [1,0,0,1,1,0,1,0,0,1,1,0]) & aa(*,kkkk) = a & corr(*,kkkk) = erg & endfor & aa(9,*) = 1.  & corr1 = ii - ii & for kkkk = 0,dy_final do begin & sin_var_1,xx,reform(aa(*,kkkk)),f & corr1(*,kkkk) = f & endfor & ii = ii/corr1 &  ibeams_merged(kk,*,*,0) = ii & endfor


endif




; correct for I -> QUV cross talk
  
   for kk = 0,n_slits -1 do begin
     

      ii1 = reform( ibeams_merged(kk,*,*,0))
      if n_elements(beta) ne 0 then ii1 = ii1 - beta*mean(ii1)
      qq1 = reform( ibeams_merged(kk,*,*,1))
      uu1 = reform( ibeams_merged(kk,*,*,2))
      vv1 = reform( ibeams_merged(kk,*,*,3))

      ; spike correction
    ;  ff = total(ii1(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)
;      corr = ff / smooth(ff,7)
 
 ;      for kkk = 0,dx_final do begin &  ii1(kkk,*) =  ii1(kkk,*) / corr  & qq1(kkk,*) =  qq1(kkk,*) / corr  & uu1(kkk,*) =  uu1(kkk,*) / corr & vv1(kkk,*) =  vv1(kkk,*) / corr  & endfor



       if n_slits gt 1 then begin

          ii1 = shift_frac(ii1,  -oofset(kk)  ,0,'C')
          qq1 = shift_frac(qq1,  -oofset(kk)  ,0,'C')
          uu1 = shift_frac(uu1,  -oofset(kk)  ,0,'C')
          vv1 = shift_frac(vv1,  -oofset(kk)  ,0,'C')
        
       ;    posslit = mean(poslines(kk,*,*,*))
       ;    ii1 = shift_frac(ii1,  posref- posslit  ,0,'C')
       ;    qq1 = shift_frac(qq1,posref- posslit,0,'C')
       ;    uu1 = shift_frac(uu1,posref- posslit ,0,'C')
       ;    vv1 = shift_frac(vv1,posref- posslit ,0,'C')
    
       endif


    

      for kkk = 0,dy_final do begin
         iline = reform(ii1(*,kkk))
         qline = reform(qq1(*,kkk))
         uline = reform(uu1(*,kkk))
         vline = reform(vv1(*,kkk))

if n_elements(tel_cal) eq 0 then begin      
         i2q = mean( qline(cont_wl(0):cont_wl(1))/iline(cont_wl(0):cont_wl(1)) )
         i2u = mean( uline(cont_wl(0):cont_wl(1))/iline(cont_wl(0):cont_wl(1)))
         i2v = mean( vline(cont_wl(0):cont_wl(1))/iline(cont_wl(0):cont_wl(1)))
           
         qline = qline - i2q*iline
         uline = uline - i2u*iline
         vline = vline - i2v*iline

endif

         if n_elements(v2q) ne 0 then begin
            qline = qline - v2q*vline
         endif
         if n_elements(v2u) ne 0 then begin
            uline = uline - v2u*vline
         endif

         
         qq1(*,kkk) = qline
         uu1(*,kkk) = uline
         vv1(*,kkk) = vline


      endfor

       ibeams_merged(kk,*,*,0) = ii1
       ibeams_merged(kk,*,*,1) = qq1
       ibeams_merged(kk,*,*,2) = uu1
       ibeams_merged(kk,*,*,3) = vv1


      
       if n_elements(plt) ne 0 then begin

          wset,kk
          if dx_final lt 800 then begin

             tvscl,congrid(ii1,dx_final,500,/interp) >0 <10000,0,0
             tvscl,congrid(qq1/ii1,dx_final,500,/interp) >(-.2) < .2,dx_final,0
             tvscl,congrid(uu1/ii1,dx_final,500,/interp)>(-.2) < .2,dx_final*2,0
             tvscl,congrid(vv1/ii1,dx_final,500,/interp)>(-.2) < .2,dx_final*3,0
          endif else begin
             tvscl,congrid(ii1,dx_final,500,/interp) >0 <10000,0,0
             tvscl,congrid(qq1/ii1,dx_final,500,/interp) >(-.2) < .2,dx_final,0

             tvscl,congrid(uu1/ii1,dx_final,500,/interp)>(-.2) < .2,dx_final*0,500
             tvscl,congrid(vv1/ii1,dx_final,500,/interp)>(-.2) < .2,dx_final*1,500

          endelse
          


      endif

      ic(kk*nsteps_total+k-scan_range(0),*) = total(ii1(cont_wl(0):cont_wl(1),*),1)/float(cont_wl(1)-cont_wl(0)+1.)

      totq(kk*nsteps_total+k-scan_range(0),*) = total( abs ( qq1(pos_solar(0):pos_solar(1),*)/ii1(pos_solar(0):pos_solar(1),*)),1)
      totu(kk*nsteps_total+k-scan_range(0),*) = total( abs ( uu1(pos_solar(0):pos_solar(1),*)/ii1(pos_solar(0):pos_solar(1),*)),1)
      totv(kk*nsteps_total+k-scan_range(0),*) = total( abs ( vv1(pos_solar(0):pos_solar(1),*)/ii1(pos_solar(0):pos_solar(1),*)),1)

   endfor


   if n_elements(plt) ne 0 then begin
      wset,4
      tvscl,congrid(ic,n_slits*nsteps_total,300,/interp) > 10 < 10000.,0,0
      tvscl,alog(congrid(totq,n_slits*nsteps_total,300,/interp) > 1),n_slits*nsteps_total,0
      tvscl,alog(congrid(totu,n_slits*nsteps_total,300,/interp) > 1),0,300
      tvscl,alog(congrid(totv,n_slits*nsteps_total,300,/interp) > 1),n_slits*nsteps_total,300

   endif




   writeu,outunit,ibeams_merged

   print,' Scan steps to go: ',scan_range(1)- k
   newt = systime(1)
   
   secsperstep = newt - oldt
   full_time = secsperstep*(scan_range(1)- k)
   print,' Time per scan step: ', secsperstep,' s'
   print,' Estimated time of termination: ',floor(full_time/3600),' h',floor( (full_time - floor(full_time/3600)*3600)/60 ),' min',round(full_time mod 60),' s'
   
   

endfor


free_lun,outunit

save,ic,totq,totu,totv,sshifts,v2q,v2u,llinepos,pos_solar,dx_final,dy_final,n_slits,filename = outfile2

if wdel17 eq 1 then wdelete,17


end

