pro firs_1565_ff,input_dir=input_dir,output_dir=output_dir,no_av = no_av,beam_ang = beam_ang,plt = plt, verbose = verbose, int_limit = int_limit,fringes = fringes,filepath = filepath,flat_file = flat_file,dark_file = dark_file,avdc_only = avdc_only


if n_elements(int_limit) eq 0 then  int_limit = .3
if n_elements(flat_file) eq 0 then  flat_file = 0
if n_elements(dark_file) eq 0 then  dark_file = 0



; sanka
output_dir = '/export/cbeck/FIRS_data/sankar20120625/reduced_20120625/'
input_dir = '/export/cbeck/FIRS_data/sankar20120625/'

; ali
;input_dir = '/export/cbeck/FIRS_data/ali20100205/firs1/'
;output_dir = '/export/cbeck/FIRS_data/ali20100205/firs1/reduced_20100205/'


input_dir = '/export/cbeck/FIRS_data/ali20100202/firs1/'
output_dir = '/export/cbeck/FIRS_data/ali20100202/firs1/reduced_20100205/'


input_dir = '/export/cbeck/obs2012/20121212/firs2/'
output_dir = '/export/cbeck/obs2012/20121212/firs2/reduced_20121212/'

input_dir = '/export/cbeck/obs2013/220113/firs/'
output_dir = '/export/cbeck/obs2013/220113/fir/reduced_220113/'

;output_dir = '/home/cbeck/firs/'
;input_dir = '/home/cbeck/firs/'

erg = read_directory(input_dir,filter ='*.sav')
outfile = erg.files
restore,input_dir+outfile(0)

;restore,input_dir+'2012625.1.sav'

; sanka
types1 = [2,1,2,1,16,16,16,0]

; 16 cal   2 map  1 ff 0 dc

; 2010 02 05 ali
types1 = [16,1,0,2,2]

; 2010 02 02 ali
types1 = [2,2,2,2,2,2,2,2,16,1,1,0]

; 2012 12 12 asc
types1 = [0,1,2,2,1,16,16,1,0,2,2,2,16,16,16,16,1]

; 2013 01 22
types1 = [2,1,0,2,0,2,2,2,1,0,16,16,1,0]


; average dark current
darkbasefile = bbasefile1(dark_file)

;  2012 12 12 asc
flatbasefile = bbasefile1(flat_file)

erg = read_directory(input_dir,filter =darkbasefile+'*')
darkfiles = erg.files(where(erg.types eq 0))
n = float(n_elements(darkfiles))

if n_elements(no_av) eq 0 then begin


print,' Averaging dc files...',darkbasefile


   fxread,input_dir+darkfiles(0),dum,hdr
   dc = dum -dum

for k = 0,n-1 do begin & fxread,input_dir+darkfiles(k),dum,hdr & dc = dc + dum/n & endfor

   save,dc,filename = output_dir+'dc.'+darkbasefile+'sav'
   
   print,' Saving dc to...',output_dir+'dc.'+darkbasefile+'sav'

   if n_elements(avdc_only) ne 0 then stop

endif

; average flatfield images


erg = read_directory(input_dir,filter =flatbasefile+'*')
flatfiles = erg.files(where(erg.types eq 0))
n = float(n_elements(flatfiles))



if n_elements(no_av) eq 0 then begin

   print,' Averaging ff files...',flatbasefile

   fxread,input_dir+flatfiles(0),dum,hdr
   ff_img = dum -dum


for k = 0,n-1 do begin & fxread,input_dir+flatfiles(k),dum,hdr & ff_img = ff_img + dum / n & endfor

   save,ff_img,filename = output_dir+'ff.'+flatbasefile+'sav'

   print,' Saving ff to...',output_dir+'ff.'+flatbasefile+'sav'

endif


restore,output_dir+'dc.'+darkbasefile+'sav'
restore,output_dir+'ff.'+flatbasefile+'sav'

outfile = output_dir +'gain.'+flatbasefile+'sav'

ff_img = ff_img - dc

ww = where(ff_img lt 0)
if ww(0) ne -1 then ff_img(ww) = 1.
ww = where(ff_img eq 0)
if ww(0) ne -1 then ff_img(ww) = 1.

ff_img1 = ff_img

ff_img2 = total(ff_img,3)/3.

tt = size(ff_img)

;if n_elements(fringes) ne 0 then goto, fringe_corr


scale = 2.
device,get_screen_size = xx  

if tt(1)/scale gt xx(0) or tt(2)/scale gt xx(1) then scale = 4.
if tt(1)/scale gt xx(0) or tt(2)/scale gt xx(1) then scale = 6.

; resize image for determination of beam locations
ff_res = congrid(ff_img2,tt(1)/scale,tt(2)/scale,/interp) 
tt1 = size(ff_res)

; make mask at int_limit * I_max
temp = ff_res
limit = int_limit*max(temp)
temp(0:1,0:1) = limit
temp(tt1(1)-2:tt1(1)-1,tt1(2)-2:tt1(2)-1) = limit

makecontplot,temp,limit,gband = 50, /noshort,mask = mmask,/filled

;mmask = median(mmask,15)
;mmask = smooth(mmask,3)

ff = where(mmask ne 0)
if ff(0) ne -1 then mmask(ff) = 1

; search for maxima in the spectral derivative
ff1 =total(mmask(*,150:200),2)/float(51.)
width = 3
nlobes = fltarr(n_elements(ff1))
rr = [abs(deriv(ff1))]
rr = [fltarr(width),rr,fltarr(width)]

rr = smooth(rr,width)

for k = width,n_elements(rr)-1-width do begin & if rr(k) gt max(rr(k-width:k-1)) and rr(k) gt max(rr(k+1:k+width)) then nlobes(k-width) = k & endfor
ff = where(nlobes ne 0)

; position of beams in x
nlobes = nlobes(ff)-width

n_slits = 1

if n_elements(nlobes) gt 2 then n_slits = 2
if n_elements(nlobes) gt 4 then n_slits = 3
if n_elements(nlobes) gt 6 then n_slits = 4

if n_elements(nlobes) eq 3 then nlobes = [nlobes,tt1(1)-1]
if n_elements(nlobes) eq 5 then nlobes = [nlobes,tt1(1)-1]
if n_elements(nlobes) eq 7 then nlobes = [nlobes,tt1(1)-1]

if n_slits eq 4 and n_elements(nlobes) lt 8 then nlobes = [nlobes ,tt1(1)-1]


if n_slits eq 4 and n_elements(nlobes) gt 8 then begin
   nnlobes = nlobes(0:7)
   nnlobes(7) = max(nlobes)
   nlobes = nnlobes
endif


if n_slits eq 4 and n_elements(nlobes) eq 8 then nlobes(7) = tt1(1)-1.


if n_elements(plt) ne 0 then begin

window,0,title = num2string(fix(n_slits))+' slits found'
plot,rr(5:*)
for k = 0,n_elements(nlobes)-1 do begin & oplot,[0,0]+nlobes(k),[0,.5*max(rr)],color = 240,thick = 3 & endfor


paused


endif


posx = fltarr(n_slits,2)
index_slit = 0.
index = 0.
for k =0,n_elements(nlobes)-1 do begin & posx(index_slit,index) = nlobes(k) & index = (index + 1) & if index eq 2 then index_slit = index_slit + 1 & index = index mod 2 & endfor

posy = fltarr(n_slits,4)

for k = 0,n_slits-1 do begin & ff =  total(mmask(posx(k,0):posx(k,1),*),1)/float(posx(k,1)-posx(k,0)) & rr =deriv(ff) & erg = min(rr(100:tt1(2)-100),posmin)& erg = max(rr(100:tt1(2)-100),posmax) & posy(k,1) = posmin+100 & posy(k,2) = posmax+100 & endfor

posy(*,1)  = posy(*,1)-posy(*,1)+median(posy(*,1))
posy(*,2)  = posy(*,2)-posy(*,2)+median(posy(*,2))

posy(*,0) = 0
posy(*,3) = tt1(2)-1

if n_elements(plt) ne 0 then begin

window,0,xs = tt1(1),ys = tt1(2),title = 'beams located'
tvscl,ff_res
for k = 0,n_slits-1 do begin & draw_rec,[posx(k,0),posx(k,1)],[posy(k,0),posy(k,1)],/device & draw_rec,[posx(k,0),posx(k,1)],[posy(k,2),posy(k,3)],/device & endfor

paused

endif

dx = fltarr(n_slits)
for k = 0,n_slits-1 do begin & dx(k) = posx(k,1)-posx(k,0) & endfor
dx = min(dx)


dy = fltarr(n_slits,2)
for k = 0,n_slits-1 do begin & dy(k,0) = posy(k,1)-posy(k,0) & dy(k,1) = posy(k,3)-posy(k,2) & endfor
dy = min(dy)


for k = 0,n_slits-1 do begin & posx(k,1) =  posx(k,0)+dx & posy(k,0) =  posy(k,1)-dy & posy(k,3) =  posy(k,2)+dy & endfor

if n_elements(plt) ne 0 then begin

window,0,xs = tt1(1),ys = tt1(2),title = 'beams located'
tvscl,ff_res
for k = 0,n_slits-1 do begin & draw_rec,[posx(k,0),posx(k,1)],[posy(k,0),posy(k,1)],/device & draw_rec,[posx(k,0),posx(k,1)],[posy(k,2),posy(k,3)],/device & endfor

paused

endif


posx = posx * scale
posy = posy * scale
dx = dx * scale
dy = dy * scale

area = fltarr(n_slits,dx+1,200)
for k = 0,n_slits -1 do begin & area(k,*,*) = ff_img1(posx(k,0):posx(k,1),dy-10:dy+189,0)/ff_img1(posx(k,0):posx(k,1),dy-10:dy+189,3) & endfor

aangle = fltarr(n_slits)
cchi = fltarr(n_slits,100)

if n_elements(plt) ne 0 then window,0,xs = dx+1, ys = 200,title ='determination of rotation'

for k = 0,n_slits-1 do begin & chi = fltarr(100) & for kk = 0,99 do begin & angle = -2.5+kk/20. & a1 = reform( rot(reform(area(k,*,*)),angle,/interp)) & a1r = reverse(a1,1) & chi(kk) =  total( abs (  a1 - a1r ) ) & if n_elements(plt) ne 0 then tvscl,a1-a1r & endfor & erg = min(chi,posmin) & cchi(k,*) = chi & aangle(k) = -2.5+posmin/20. & endfor

if n_slits gt 1 then begin
   if n_slits eq 2 then diff = aangle(1)-aangle(0)
   if n_slits eq 3 then diff = [aangle(1)-aangle(0),aangle(2)-aangle(0),aangle(1)-aangle(2)]
   if n_slits eq 4 then diff = [aangle(1)-aangle(0),aangle(2)-aangle(0),aangle(3)-aangle(0),aangle(1)-aangle(2),aangle(3)-aangle(2),aangle(3)-aangle(1)]
   diff_max = max(abs(diff))
   if diff_max gt 0.3 then begin
      print,'!! firs_630_ff: Warning !! Rotation angles vary by more than 0.3 deg'
      print,'Angles: ',aangle

      window,0,title ='rotation angle'
      !p.multi = [n_slits,1,n_slits]
   for k = 0,n_slits-1 do begin & plot,-2.5+findgen(100)/20.,cchi(k,*) & endfor
      
      ans = read_keyboard('Please enter value to be used: ',/number)
      aangle = aangle -aangle + ans

   endif


endif




if n_elements(plt) ne 0 then begin
   window,0,title ='rotation angle'
   !p.multi = [n_slits,1,n_slits]

for k = 0,n_slits-1 do begin & plot,-2.5+findgen(100)/20.,cchi(k,*) & oplot,[0,0]+aangle(k),[0,max(cchi(k,*))] &  endfor
   
   paused
endif



if n_elements(beam_ang) ne 0 then begin
   if n_elements(beam_ang) eq 1 then aangle = fltarr(n_slits)+beam_ang else aangle = beam_ang 
endif


ii = fltarr(n_slits,2,dx+1,dy+1,4)
for k = 0,n_slits-1 do begin & for kk = 0,3 do begin &  ff_temp = reform(ff_img1(*,*,kk)) &  & ii(k,0,*,*,kk) = ff_temp(posx(k,0):posx(k,1),posy(k,0):posy(k,1)) & ii(k,1,*,*,kk) = ff_temp(posx(k,0):posx(k,1),posy(k,2):posy(k,3)) & endfor & endfor

; ff_temp = rot(ff_temp,aangle(k),/interp)

if n_elements(plt) ne 0 then begin

for k = 0,n_slits -1 do begin & window,k,xs = 2*dx,ys = dy,title='beams in slit '+num2string(k)+' mod. state 0' & tvscl,ii(k,0,*,*,0),0,0 & tvscl,ii(k,1,*,*,0),dx,0 & endfor

paused

endif


eerg = fltarr(n_slits,2)
for k =0,n_slits -1 do begin  & erg = shc( reform(ii(k,0,50:dx-50,50:dy-50,0)),reform(ii(k,1,50:dx-50,50:dy-50,0)),/filt) & eerg(k,*) = erg & print,erg & endfor 

if n_slits gt 1 then begin
   if n_slits eq 2 then diff = eerg(1,1)-eerg(0,1)
   if n_slits eq 3 then diff = [eerg(1,1)-eerg(0,1),eerg(2,1)-eerg(0,1),eerg(1,1)-eerg(2,1)]
   if n_slits eq 4 then diff = [eerg(1,1)-eerg(0,1),eerg(2,1)-eerg(0,1),eerg(3,1)-eerg(0,1),eerg(1,1)-eerg(2,1),eerg(3,1)-eerg(2,1),eerg(3,1)-eerg(1,1)]
   diff_max = max(abs(diff))
   if diff_max gt 10 then begin
      print,'!! firs_630_ff: Warning !! Vertical shifts for beam alignment deviate more than 10 pixels'
      print,'Shifts along slit: ',eerg(*,1)
      ans = read_keyboard('Please enter value to be used: ',/number)
      
   endif

   if diff_max gt 10 then begin

   check_shift:

   eerg = fltarr(n_slits,2)
   for k =0,n_slits -1 do begin  & i1 = reform(ii(k,0,*,*,0)) & i2 = reform(ii(k,1,*,*,0)) & i2 = shift(i2,0,ans) & erg = shc( reform(i1(50:dx-50,50:dy-50,0)),reform(i2(50:dx-50,50:dy-50,0)),/filt) & eerg(k,*) = erg+[0,ans] & print,eerg(k,1) & endfor 

      ans = read_keyboard('Accept new shifts: y/n ')
      if ans eq 'n' then begin
         ans = read_keyboard('Please enter value to be used: ',/number)
         goto,check_shift
      endif
   endif



endif



; & for kk = 0,3 do begin & endfor

shiftx = max( abs(eerg(*,0)))
shifty = max( abs(eerg(*,1)))

dx_final = dx - shiftx
dy_final = dy - shifty

ii1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

posx_final = posy-posy
posy_final = posy-posy



for k =0,n_slits-1 do begin 


    for kk = 0,3 do begin
   if eerg(k,0) lt 0 and  eerg(k,1) lt 0  then begin
      ii1(k,0,*,*,kk) = ii(k,0,0:dx_final,0:dy_final,kk)
      ii1(k,1,*,*,kk) = ii(k,1,abs(eerg(k,0)):abs(eerg(k,0))+dx_final,abs(eerg(k,1)):abs(eerg(k,1))+dy_final,kk)

      posx_final(k,0) = 0
      posx_final(k,1) = dx_final
      posx_final(k,2) = abs(eerg(k,0))
      posx_final(k,3) = abs(eerg(k,0))+dx_final
      
      posy_final(k,0) = 0
      posy_final(k,1) = dy_final
      posy_final(k,2) = abs(eerg(k,1))
      posy_final(k,3) = abs(eerg(k,1))+dy_final
      

   endif 
   if eerg(k,0) ge 0 and  eerg(k,1) ge 0  then begin
      ii1(k,1,*,*,kk) = ii(k,1,0:dx_final,0:dy_final,kk)
      ii1(k,0,*,*,kk) = ii(k,0,abs(eerg(k,0)):abs(eerg(k,0))+dx_final,abs(eerg(k,1)):abs(eerg(k,1))+dy_final,kk)

      posx_final(k,2) = 0
      posx_final(k,3) = dx_final
      posx_final(k,0) = abs(eerg(k,0))
      posx_final(k,1) = abs(eerg(k,0))+dx_final
      
      posy_final(k,2) = 0
      posy_final(k,3) = dy_final
      posy_final(k,0) = abs(eerg(k,1))
      posy_final(k,1) = abs(eerg(k,1))+dy_final

   endif 
   
    if eerg(k,0) lt 0 and  eerg(k,1) ge 0  then begin
      ii1(k,0,*,*,kk) = ii(k,0,0:dx_final,abs(eerg(k,1)):abs(eerg(k,1))+dy_final,kk)
      ii1(k,1,*,*,kk) = ii(k,1,abs(eerg(k,0)):abs(eerg(k,0))+dx_final,0:dy_final,kk)

      posx_final(k,0) = 0
      posx_final(k,1) = dx_final
      posx_final(k,2) = abs(eerg(k,0))
      posx_final(k,3) = abs(eerg(k,0))+dx_final
      
      posy_final(k,2) = 0
      posy_final(k,3) = dy_final
      posy_final(k,0) = abs(eerg(k,1))
      posy_final(k,1) = abs(eerg(k,1))+dy_final


   endif 

    if eerg(k,0) ge 0 and  eerg(k,1) lt 0  then begin
      ii1(k,1,*,*,kk) = ii(k,1,0:dx_final,abs(eerg(k,1)):abs(eerg(k,1))+dy_final,kk)
      ii1(k,0,*,*,kk) = ii(k,0,abs(eerg(k,0)):abs(eerg(k,0))+dx_final,0:dy_final,kk)

      posx_final(k,2) = 0
      posx_final(k,3) = dx_final
      posx_final(k,0) = abs(eerg(k,0))
      posx_final(k,1) = abs(eerg(k,0))+dx_final
      
      posy_final(k,0) = 0
      posy_final(k,1) = dy_final
      posy_final(k,2) = abs(eerg(k,1))
      posy_final(k,3) = abs(eerg(k,1))+dy_final

   endif 
endfor

endfor


if n_elements(plt) ne 0 then begin

for k = 0,n_slits -1 do begin & window,k,xs = 2*dx,ys = dy,title='aligned beams in slit '+num2string(k)+' mod. state 1' & tvscl,ii1(k,0,*,*,0),0,0 & tvscl,ii1(k,1,*,*,0),dx,0 & endfor

paused

endif

dc1 = reform(dc(*,*,0))

lastx = dx_final+1
firsty = 0
lasty = dy_final+1

gaintable = fltarr(n_slits,2,dx_final+1,dy_final+1,4)
pposref = fltarr(n_slits,2,4)
gaintablecoarse = fltarr(n_slits,2,dx_final+1,dy_final+1,4)


for k = 0,n_slits -1 do begin 

   for kk =0,1 do begin

       for kkkk = 0,3 do begin

      iref = reform(ii1(k,kk,*,*,kkkk))
 
      ff = total(iref,2)

      if kk eq 0 and kkkk eq 0 then begin
  ; determine location of spectral lines
            iline = ff
            iline = abs(iline/float(max(iline))-1)
          
            n = length(iline)
            ilobes = fltarr(n-4)
            threshh = .2
            ilobeindex = 0.
            for kkk = 5,n-5 do begin
                if iline(kkk) gt max(iline(kkk+1:kkk+4)) and iline(kkk) gt max(iline(kkk-4:kkk-1)) and iline(kkk) gt threshh then begin
                    ilobes(ilobeindex) = kkk
                    ilobeindex = ilobeindex+1
                endif
            endfor
            if ilobeindex ne 2 then begin
                print,' Automatic detection of spectral lines failed.'
                print,' Please select lines manually:'
                window,0
                !p.multi = 0
                plot,iline        
                ilobeindex = 0.
                ilobes = fltarr(n-4)
                while ilobeindex ne 2 do begin
                    wset,0
                    cursor,x,y,/data,/wait
                    if !mouse.button eq 1 then begin
                        ilobes(ilobeindex) = x
                        ilobeindex = ilobeindex+1
                        print,'Line ',ilobeindex
                        print,'at ',x
                        oplot,[x,x],[0,1]
                        wait,.5
                    endif
                    if ilobeindex eq 2 then begin
                        ans = read_keyboard('Selection okay y(es)/n(o) ')
                        if ans eq 'n' then begin
                            ilobeindex = 0
                            plot,iline    
                        endif
                    endif
                endwhile
            endif
            ilobes = ilobes(0:ilobeindex-1)
            ilobes = ilobes(sort(ilobes))
            
            range_telu = [-15,15]+ilobes(0)

            ilo = range_telu(0)
            ihi = range_telu(1)
            wave_lim = [ilobes(0)-30,ilobes(1)+20,.5]
         endif

;stop
;      create_gaintables_firs_630,ilo,ihi,lastx,firsty,lasty,iref,dc1,gainsave,gaincoarse,posref,wave_lim = wave_lim,plt = plt,verbose =verbose
      create_gaintables_firs_630,ilo,ihi,lastx,firsty,lasty,iref,dc1,gainsave,gaincoarse,posref,wave_lim = wave_lim,verbose =verbose

      pposref(k,kk,kkkk) = posref


      if n_elements(plt) ne 0 then begin

         window,0,xs = 3*(dx_final+1),ys = dy_final+1,title = 'gain of slit '+num2string(k)+', beam '+num2string(kk)
         tvscl,iref,0,0
         tvscl,iref/gainsave,dx_final+1,0
         tvscl,gainsave > .85 < 1.15,2*(dx_final+1),0
         paused
      endif
      
      gaintable(k,kk,*,*,kkkk) = gainsave
      
      gaintablecoarse(k,kk,*,*,kkkk) = gaincoarse

  endfor

   endfor


endfor


if n_slits gt 1 then begin
    print,'Balancing the slits...'

   

    ii11 = ii1/gaintable
    ii11coarse = ii1/gaintablecoarse
    mean_slits = fltarr(n_slits,2,4)
    mean_slitscoarse = fltarr(n_slits,2,4)

 for k = 0,n_slits -1 do begin & for kk = 0,1 do begin & for kkk = 0,3 do begin & mean_slits(k,kk,kkk) = mean(ii11(k,kk,50:dx_final-50,50:dy_final-50,kkk)) & endfor & endfor & endfor

 for k = 0,n_slits -1 do begin & for kk = 0,1 do begin & for kkk = 0,3 do begin & mean_slitscoarse(k,kk,kkk) = mean(ii11coarse(k,kk,50:dx_final-50,50:dy_final-50,kkk)) & endfor & endfor & endfor

        iref = mean(mean_slits)
        irefcoarse = mean(mean_slitscoarse)

    for k = 0,n_slits -1 do begin & for kk = 0,1 do begin & for kkk = 0,3 do begin & gaintable(k,kk,*,*,kkk) = gaintable(k,kk,*,*,kkk)*mean_slits(k,kk,kkk)/iref & endfor & endfor & endfor
    for k = 0,n_slits -1 do begin & for kk = 0,1 do begin & for kkk = 0,3 do begin & gaintablecoarse(k,kk,*,*,kkk) = gaintablecoarse(k,kk,*,*,kkk)*mean_slitscoarse(k,kk,kkk)/irefcoarse & endfor & endfor & endfor

        ii11 = ii1/gaintable

        mean_slits1 = mean_slits - mean_slits

     for k = 0,n_slits -1 do begin & for kk = 0,1 do begin & for kkk = 0,3 do begin & mean_slits1(k,kk,kkk) = mean(ii11(k,kk,50:dx_final-50,50:dy_final-50,kkk)) & endfor & endfor & endfor
;        print,mean_slits
;stop

        if n_elements(plt) ne 0 then begin
            window,0,xs = 4*100*n_slits,ys = dy_final / 4.*2.

        for k = 0,n_slits - 1 do begin & for kk = 0,3 do begin & tvscl,congrid(reform(ii11(k,0,*,*,kk)),100,dy_final / 4.),kk*100+k*400,0 & tvscl,congrid(reform(ii11(k,1,*,*,kk)),100,dy_final / 4.),kk*100+k*400,dy_final/4. & endfor & endfor


        endif


endif


dum = ff_img

ibeams = fltarr(n_slits,2,dx+1,dy+1,4)
for kk = 0,n_slits-1 do begin &  ii_temp = reform(dum(*,*,0)) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = reform(dum(*,*,1)) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = reform(dum(*,*,2)) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = reform(dum(*,*,3)) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

   ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk) /gaintable(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk) / gaintable(kk,1,*,*,kkk)  & endfor & endfor

for kk = 0,n_slits-1 do begin & for kkk = 0,3 do begin & ff = reform(total(ibeams1(kk,0,*,*,kkk),4)) & xx = findgen(dx_final+1) & erg = poly_fit(xx,ff(xx),3,/double) & yy = erg(0)+erg(1)*findgen(dx_final+1)+erg(2)*findgen(dx_final+1)^2.+erg(3)*findgen(dx_final+1)^3. & yy = yy / mean(yy) & for kkkk = 0,dy_final do begin & ibeams1(kk,0,*,kkkk,kkk) = ibeams1(kk,0,*,kkkk,kkk) / yy & endfor  & ff = reform(total(ibeams1(kk,1,*,*,kkk),4)) & xx = findgen(dx_final+1) & erg = poly_fit(xx,ff(xx),3,/double) & yy = erg(0)+erg(1)*findgen(dx_final+1)+erg(2)*findgen(dx_final+1)^2.+erg(3)*findgen(dx_final+1)^3. & yy = yy / mean(yy) & for kkkk = 0,dy_final do begin & ibeams1(kk,1,*,kkkk,kkk) = ibeams1(kk,1,*,kkkk,kkk) / yy & endfor & endfor & endfor


llinepos = fltarr(n_slits,2,dy_final+1,4)

for kk = 0,n_slits-1 do begin & for kkk = 0,3 do begin & ff = reform(ibeams1(kk,0,*,*,kkk)) & for kkkk = 0,dy_final do begin & iline = reform(ff(*,kkkk)) & erg = min(iline(pposref(kk,0,kkk)-15:pposref(kk,0,kkk)+15),posmin) & posmin = posmin + pposref(kk,0,kkk)-15 & lpff,iline(posmin-5:posmin+5),pposmin & pposmin = pposmin + posmin -5 & llinepos(kk,0,kkkk,kkk) = pposmin & endfor &  ff = reform(ibeams1(kk,1,*,*,kkk)) & for kkkk = 0,dy_final do begin & iline = reform(ff(*,kkkk)) & erg = min(iline(pposref(kk,0,kkk)-15:pposref(kk,0,kkk)+15),posmin) & posmin = posmin + pposref(kk,0,kkk)-15 & lpff,iline(posmin-5:posmin+5),pposmin & pposmin = pposmin + posmin -5 & llinepos(kk,1,kkkk,kkk) = pposmin & endfor & endfor & endfor 



print,' Saving gain to...',outfile

save,aangle,dx,dy,dx_final,dy_final,posx,posy,posx_final,posy_final,gaintable,gaintablecoarse,cchi,n_slits,pposref,mean_slits,mean_slitscoarse,mean_slits1,llinepos,filename = outfile

if n_elements(plt) ne 0 then wdelete,0,1

if n_elements(fringes) ne 0 then begin

;fringe_corr:

   restore,outfile

; jj
   tip_x = 0.
   tip_y = 0.
   model_num = 73.
   disp = 5.5
   prof_type = 0
   lineindex = [3,5]
   if n_elements(filepath) eq 0 then filepath ='/export/cbeck/sir_collection/sir/'
   infile = filepath+'prof.per'


   llineindex = intarr(dx_final+1)+3
   n_tot = dx_final + 1


   dum = ff_img

   ibeams = fltarr(n_slits,2,dx+1,dy+1,4)
for kk = 0,n_slits-1 do begin &  ii_temp = reform(dum(*,*,0)) & ibeams(kk,0,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1))  & ibeams(kk,1,*,*,0) = ii_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & qq_temp = reform(dum(*,*,1)) & ibeams(kk,0,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,1) = qq_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & uu_temp = reform(dum(*,*,2)) & ibeams(kk,0,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,2) = uu_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & vv_temp = reform(dum(*,*,3)) & ibeams(kk,0,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,0):posy(kk,1)) & ibeams(kk,1,*,*,3) = vv_temp(posx(kk,0):posx(kk,1),posy(kk,2):posy(kk,3)) & endfor

   ibeams1 = fltarr(n_slits,2,dx_final+1,dy_final+1,4)

for kk = 0,n_slits-1 do begin & ibeams1(kk,0,*,*,*) =  ibeams(kk,0,posx_final(kk,0):posx_final(kk,1), posy_final(kk,0): posy_final(kk,1),*) & ibeams1(kk,1,*,*,*) =  ibeams(kk,1,posx_final(kk,2):posx_final(kk,3), posy_final(kk,2): posy_final(kk,3),*) & endfor

 for kk = 0,n_slits -1 do begin &  for kkk = 0,3 do begin & ibeams1(kk,0,*,*,kkk) =  ibeams1(kk,0,*,*,kkk) /gaintable(kk,0,*,*,kkk) & ibeams1(kk,1,*,*,kkk) =  ibeams1(kk,1,*,*,kkk) / gaintable(kk,1,*,*,kkk)  & endfor & endfor

 for kk = 0,n_slits-1 do begin & for kkk = 0,3 do begin & ff = reform(total(ibeams1(kk,0,*,*,kkk),4)) & xx = findgen(dx_final+1) & erg = poly_fit(xx,ff(xx),3,/double) & yy = erg(0)+erg(1)*findgen(dx_final+1)+erg(2)*findgen(dx_final+1)^2.+erg(3)*findgen(dx_final+1)^3. & yy = yy / mean(yy) & for kkkk = 0,dy_final do begin & ibeams1(kk,0,*,kkkk,kkk) = ibeams1(kk,0,*,kkkk,kkk) / yy & endfor  & ff = reform(total(ibeams1(kk,1,*,*,kkk),4)) & xx = findgen(dx_final+1) & erg = poly_fit(xx,ff(xx),3,/double) & yy = erg(0)+erg(1)*findgen(dx_final+1)+erg(2)*findgen(dx_final+1)^2.+erg(3)*findgen(dx_final+1)^3. & yy = yy / mean(yy) & for kkkk = 0,dy_final do begin & ibeams1(kk,1,*,kkkk,kkk) = ibeams1(kk,1,*,kkkk,kkk) / yy & endfor & endfor & endfor

;& plot,wavel,total(ii,2)/(dy_final+1.) & oplot,[0,0]+1564.85,[0,2] & oplot,[0,0]+1565.28,[0,2] 

    cd,filepath

    fringe_corr = gaintable - gaintable

 for kk = 0,n_slits-1 do begin & for kkk = 0,3 do begin &  ii = reform(ibeams1(kk,0,*,*,kkk)) & ic = mean(ii(120:130,*)) & ii = ii / ic & wavel = 1564.8515 + (findgen(dx_final+1)-pposref(kk,0,kkk))*disp/1000. & wavel = wavel*10. - 15648.515 & wavel = wavel*1000. & wavel = round(wavel(0))+ findgen(dx_final+1)*disp*10. & write_sir_grid_firs,filepath+'wavelength.grid',lineindex,wavel(0),wavel(dx_final),disp*10.,/blend & for kkkk = 0,dy_final do begin & i = reform(ii(*,kkkk)) & q = i -i  & u = i -i  & v = i -i & write_sir_profiles,infile,llineindex,wavel,i,q,u,v & perform_inversion_laptop,filepath,i_fit,q_fit,u_fit,v_fit,n_tot,model_num,model,model1,model2,firstline1,firstline2,prof_type,1,error_status,tip_x,tip_y,/quiet & fringe_corr(kk,0,*,kkkk,kkk) = i_fit/i & if n_elements(plt) ne 0 then tvscl, fringe_corr(kk,0,*,*,kkk) & print,dy_final-kkkk,kkk,kk & endfor & ii = reform(ibeams1(kk,1,*,*,kkk)) &  ic = mean(ii(120:130,*)) & ii = ii / ic  & for kkkk = 0,dy_final do begin & i = reform(ii(*,kkkk)) & q = i -i  & u = i -i  & v = i -i & write_sir_profiles,infile,llineindex,wavel,i,q,u,v & perform_inversion_laptop,filepath,i_fit,q_fit,u_fit,v_fit,n_tot,model_num,model,model1,model2,firstline1,firstline2,prof_type,1,error_status,tip_x,tip_y,/quiet & fringe_corr(kk,1,*,kkkk,kkk) = i_fit/i & if n_elements(plt) ne 0 then tvscl, fringe_corr(kk,1,*,*,kkk) & print,dy_final-kkkk,kkk,kk & endfor & endfor & endfor

    outfile = output_dir +'fringecorr.'+flatbasefile+'sav'
    print,' Saving fringe correction to...',outfile

    save,fringe_corr,filename = outfile

 endif







stop

end

