function float2int,array,unsigned=unsigned

;+
;============================================================================
;
;	function : float2int
;
;	purpose  : transform data array in floating format into integer array.
;
;       calls    : round.pro, fix.pro (idl-implemented)
;
;	written :  cbeck@KIS 06/02
;
;==============================================================================
;
;	Check number of arguments.
;
;==============================================================================
if (n_params() lt 1) then begin
	print
	print, "usage:  i = float2int(array,unsigned)
	print
	print, "	Transform floating array into integer array,"
        print, "        either signed or unsigned."
        print
	print, "	Arguments"
        print, "                Input :"
        print, "		array : floating array
        print
        print, "                Output:"
        print, "                (un)signed integer array, rounded"
        print
        print, "        Keywords:"
        print, "                /unsigned : transform to unsigned integer"
        print
        return,0
endif
;==============================================================================
;-

;-----------------------------------------------------------------------------
; default conversion: signed integer (-32768:32767)
;-----------------------------------------------------------------------------
type = 2

;-----------------------------------------------------------------------------
; keyword /unsigned set: unsigned integer (0:65535)
;-----------------------------------------------------------------------------
if n_elements(unsigned) ne 0 then begin
type = 12
ff = where(array lt 0)
if ff(0) ne -1 then array(ff) = 0
endif

;-----------------------------------------------------------------------------
; convert array using round.pro and fix.pro
;-----------------------------------------------------------------------------
int_array = fix(round(array),type=type)

return,int_array
end


