pro generate_firs_archive_files,inpath=inpath,outpath=outpath, no_swap = no_swap,pollimit = pollimit,fast = fast, pp1 = pp1,target = target, comments = comments,help = help,tip2 = tip2,twice = twice,ps = ps,change_save = change_save,swap= swap,wavelen= wavelen,n_slits = n_slits,check_lines = check_lines,ddeskew = ddeskew,wwidth = wwidth,iinput_dir = iinput_dir

if n_elements(wwidth) eq 0 then wwidth = 1

if n_elements(n_slits) eq 0 then n_slits = 1
if n_elements(pp1) eq 0 then pp1 = 0
if n_elements(wavelen) eq 0 then wavelen = 15650.

int_only = 0

cr = string(13b)

; set input path to current directory 
if n_elements(inpath) eq 0 then begin
cd,current = current
inpath = current+'/'
endif

; default values for limit in polarization
if n_elements(pollimit) eq 0 then pollimit = .007
; set output path to current directory if not specified otherwise
if n_elements(outpath) eq 0 then outpath = inpath

; read in all calibrated data files
erg = read_directory(inpath,filter = 'firs*dat')

files1 = erg.files(where(erg.types eq 0))
files = inpath+erg.files(where(erg.types eq 0))
nfiles = n_elements(files)

print,' Found '+num2string(fix(nfiles))+' files in ',inpath+'.'


savefiles = files+'.sav'

sampl = 0.18

if wavelen eq 630 then sampl = .09

stepwidth = 0.3
expo = 125.
nnaccum = 8.
integtime = 4*expo*nnaccum/1000.
;wavelen = 1083
corr_status = 'AO' 
px = 0
py = 0

;    if n_elements(tip2) ne 0 then sampl = 0.173
;    if n_elements(twice) ne 0 then  sampl = sampl*2

    if n_elements(comments) ne 0 then begin
        if n_elements(comments) ne nfiles then comments = strarr(nfiles)+comments
    endif
    if n_elements(target) ne 0 then begin
        if n_elements(target) ne nfiles then target = strarr(nfiles)+target
    endif

  
;stop

; loop over files
    for k = 0,nfiles-1 do begin ; float(nfiles-1)

 ; if k eq 0 then wwidth = 1


; to be included from raw file
; read header information 

restore,savefiles(k)
tt = size(ic)         
scan_steps = tt(1)

yyear = string2num(strmid(files1(k),7, 4))
mmonth= string2num(strmid(files1(k),11, 2))
dday  = string2num(strmid(files1(k),13, 2))
hhour = string2num(strmid(files1(k),16, 2))
mmin = string2num(strmid(files1(k),18, 2))
ssec = string2num(strmid(files1(k),20, 2))

schour = hhour
scmin = mmin
scsec = ssec

if n_elements(iinput_dir) ne 0 then begin

   base_file = strmid(files1(k),0, 23)
  
   erg = read_directory(iinput_dir,filter =base_file+'*')
   ffiles = erg.files



; get start time and header info
   ffxread,iinput_dir+ffiles(0),dat,hdr,/NODATA    
   expo = FXPAR(hdr,'EXP_TIME')
   nnaccum  = FXPAR(hdr,'SUMS')
   integtime = expo*8*nnaccum/1000.

   jump =  n_elements(where(erg.types eq 0))
   time = string2num(FXPAR(hdr,'OBS_STAR',COUNT = obs_star_exist),divider ='T:.')
  
   if n_elements(time) lt 2 then    time = string2num(FXPAR(hdr,'DST_TIME',COUNT = obs_star_exist),divider ='T:.')

   timestart = time(1:3)
  
; get end time
   ffxread,iinput_dir+ffiles(0+jump-1),dat,hdr,/NODATA    
   time = string2num(FXPAR(hdr,'OBS_STAR',COUNT = obs_star_exist),divider ='T:.')

   if n_elements(time) lt 2 then    time = string2num(FXPAR(hdr,'DST_TIME',COUNT = obs_star_exist),divider ='T:.')

   timeend = time(1:3)
  
   hhour = timestart(0)
   mmin = timestart(1)
   ssec = timestart(2)
   schour = timeend(0)
   scmin = timeend(1)
   scsec = timeend(2)

   px = FXPAR(hdr,'DST_XGDR')
   py = FXPAR(hdr,'DST_YGDR')

;   stepwidth

endif




; generate text file with header information
out_text =  outpath+files1(k)+'.txt'
openw,out_unit,out_text,/get_lun
printf,out_unit,'File: '+files1(k)
printf,out_unit,'Date: '+num2string(fix(yyear))+'/'+num2string(fix(mmonth))+'/'+num2string(fix(dday))
            if hhour lt 10 then hhourtext = '0'+num2string(fix(hhour)) else hhourtext = num2string(fix(hhour))
            if mmin lt 10 then mmintext = '0'+num2string(fix(mmin)) else mmintext = num2string(fix(mmin))
            if ssec lt 10 then ssectext = '0'+num2string(fix(ssec)) else ssectext = num2string(fix(ssec))
                
        if schour lt 10 then schourtext = '0'+num2string(fix(schour)) else schourtext = num2string(fix(schour))
        if scmin lt 10 then scmintext = '0'+num2string(fix(scmin)) else scmintext = num2string(fix(scmin))
        if scsec lt 10 then scsectext = '0'+num2string(fix(scsec)) else scsectext = num2string(fix(scsec))

        printf,out_unit,'Time: '+hhourtext+':'+mmintext+':'+ssectext+' until '+schourtext+':'+scmintext+':'+scsectext
        printf,out_unit,'# steps,stepwidth: '+num2string(fix(tt(1)))+','+num2string(stepwidth)
        printf,out_unit,'Scan area: '+num2string(scan_steps*stepwidth)+'x'+num2string(tt(2)*sampl)
        printf,out_unit,'Exp. time,n_acum,tot.integ.time: '+num2string(expo)+','+num2string(fix(nnaccum))+','+num2string(integtime)
        printf,out_unit,'Wavelength: '+num2string(fix(wavelen))

        theta = asin(sqrt(px^2.+py^2.)/960.)*180/!pi
        printf,out_unit,'posx, posy, hel. angle: '+num2string(px(0))+','+num2string(py(0))+','+num2string(theta(0))
        printf,out_unit,'Image correction: '+corr_status

if n_elements(target) eq 0 then printf,out_unit,'Target: ' else printf,out_unit,'Target: '+target(k)
 if n_elements(comments) eq 0 then printf,out_unit,'Comments: 'else printf,out_unit,'Comments: '+comments(k)
        printf,out_unit,' '
        free_lun,out_unit

        
        if pp1 eq 0 then begin
; determine location of spectral lines

           if int_only eq 0 then begin
              if n_slits eq 1 then a = fltarr(dx_final+1,dy_final+1,4) else a = fltarr(n_slits,dx_final+1,dy_final+1,4)
           endif else begin
               if n_slits eq 1 then a = fltarr(dx_final+1,dy_final+1) else a = fltarr(n_slits,dx_final+1,dy_final+1)
           endelse


           openr,in_unit,files(k),/get_lun
           readu,in_unit,a
           free_lun,in_unit

           

           if n_slits eq 1 then iline = total(reform(a(*,*,0)),2) else iline = total(reform(a(0,*,*,0)),2)
           if total(iline) eq 0 then goto,nextfile
           iline = abs(iline/float(max(iline))-1)
                                ;         if wavelen lt 1500. and n_elements(iline) gt 550 then  iline =  iline(0:549)
           n = length(iline)
           iline = smooth(iline,15)
           ilobes = fltarr(n-4)
           threshh = .15        ;.2
           ilobeindex = 0.
           for kkk = 5,n-5 do begin
              if iline(kkk) gt max(iline(kkk+1:kkk+4)) and iline(kkk) gt max(iline(kkk-4:kkk-1)) and iline(kkk) gt threshh then begin
                 ilobes(ilobeindex) = kkk
                 ilobeindex = ilobeindex+1
              endif
           endfor                    
           
           
           if ilobeindex ne 2 or n_elements(check_lines) ne 0 then begin ;
              print,' Automatic detection of spectral lines failed.'
              print,' Please select lines manual:'
              window,0
              plot,iline       
              ilobeindex = 0.
              ilobes = fltarr(n-4)
              while ilobeindex ne 2 do begin
                 wset,0
                 cursor,x,y,/data,/wait
                 if !mouse.button eq 1 then begin
                    ilobes(ilobeindex) = x
                    ilobeindex = ilobeindex+1
                    print,'Line ',ilobeindex
                    print,'at ',x
                    oplot,[x,x],[0,1]
                    wait,.5
                 endif
                 if ilobeindex eq 2 then begin
                    ans = read_keyboard('Selection okay y(es)/n(o) ')
                    if ans eq 'n' then begin
                       ilobeindex = 0
                       plot,iline    
                    endif
                 endif
              endwhile
           endif
           ilobes = ilobes(0:ilobeindex-1)
           ilobes = ilobes(sort(ilobes))

     
if tt(1)*2 gt 1500 then xxsize = 1500 else xxsize = tt(1)*2.
           window,0,xsize = xxsize,ysize = tt(2)*2
           tvscl,ic,0,0
           tvscl,alog(totv),tt(1),0
           v48 = fltarr(tt(1),tt(2))
           v52 = v48 
           bb  = v48
           polarity = v48
           coremap = v48
           
           line48 = [ilobes(0)-30,ilobes(0)+30]
           line52 = [ilobes(1)-30,ilobes(1)+30]
           
           if line48(0) lt 0 then  line48(0) = 0.
           if line52(0) lt 0 then  line52(0) = 0.
     ;      if wavelen eq 10830 then line52 = [ilobes(1)-5,ilobes(1)+5]
           



           print,'Processing: '+files1(k)
; loop over scan steps
; determine line core positions of all spectral lines

           if int_only eq 0 then begin
              if n_slits eq 1 then a = fltarr(dx_final+1,dy_final+1,4) else a = fltarr(n_slits,dx_final+1,dy_final+1,4)
           endif else begin
              if n_slits eq 1 then a = fltarr(dx_final+1,dy_final+1) else a = fltarr(n_slits,dx_final+1,dy_final+1)
           endelse
;           if n_slits eq 1 then a = fltarr(dx_final+1,dy_final+1,4) else a = fltarr(n_slits,dx_final+1,dy_final+1,4)

           openr,in_unit,files(k),/get_lun

            for l = 0.,tt(1)/float(n_slits)-1 do begin
               tip_x = l
               readu,in_unit,a

               if int_only eq 0 then begin
               if n_slits eq 1 then begin
                  i = reform(a(*,*,0))
                  q = reform(a(*,*,1))
                  u = reform(a(*,*,2))
                  v = reform(a(*,*,3))
               endif else begin
                  i = reform(a(*,*,*,0))
                  q = reform(a(*,*,*,1))
                  u = reform(a(*,*,*,2))
                  v = reform(a(*,*,*,3))
               endelse
            endif else begin
               
              
               if n_slits eq 1 then begin
                  i = reform(a(*,*,0))
                  q = reform(a(*,*,0))
                  u = reform(a(*,*,0))
                  v = reform(a(*,*,0))
               endif else begin
                  i = reform(a(*,*,*,0))
                  q = reform(a(*,*,*,0))
                  u = reform(a(*,*,*,0))
                  v = reform(a(*,*,*,0))
               endelse
            endelse

   
               if n_elements(swap) ne 0 then begin
                  i = swap_endian(i)
                  q = swap_endian(q)
                  u = swap_endian(u)
                  v = swap_endian(v)
               endif

               if n_elements(ddeskew) ne 0 then begin


               for kk = 0,n_slits-1 do begin 
                  
                  if n_slits eq 1 then begin
                     ii = i
                     qq = q
                     uu = u
                     vv = v
                  endif else begin
                      ii = reform(i(kk,*,*))
                      qq = reform(q(kk,*,*))
                      uu = reform(u(kk,*,*))
                      vv = reform(v(kk,*,*))
                  endelse

                  
                  deskew1,ii,qq,uu,vv,ilobes(0)-15,ilobes(0)+15,0,dy_final,0,dy_final,1,posref,plt=plt,straight = straight,third_order = third_order,ll = ll

                  if n_slits eq 1 then begin
                     i = ii
                     q = qq
                     u = uu
                     v = vv
                  endif else begin
                      i(kk,*,*) = ii
                      q(kk,*,*) = qq
                      u(kk,*,*) = uu
                      v(kk,*,*) = vv

                  endelse
               endfor

             

            endif



if n_slits eq 1 then begin               
                                ; loop along slit
                for kk = 0,tt(2)-1 do begin
                    iline = smooth(float(i(*,kk)),5)

                    erg = min(iline(line48(0):line48(1)),posmin)
                    posmin = posmin+line48(0)
                    if posmin lt 3 then posmin = 3

                    lpff,iline(posmin-3:posmin+3),pos48
                    pos48 = pos48+posmin-3
                
                
                    erg = min(iline(line52(0):line52(1)),posmin)
                    posmin = posmin+line52(0)
                    if posmin lt 3 then posmin = 3

                    lpff,iline(posmin-3:posmin+3),pos52
                    pos52 = pos52+posmin-3
                   
                    v52(l,kk) = pos52
                    v48(l,kk) = pos48
                    
                    coremap(l,kk) =total(iline(posmin-3:posmin+3)) ; iline(posmin-30)-total(iline(posmin-3:posmin+3))/7.;total(iline(posmin-3:posmin+3))


; determine polarity and polarization degree in Stokes V
                    vline = v(line48(0):line48(1),kk)/float(i(line48(0):line48(1),kk))
                    
                    
                   
                    erg = min(vline,posmin)
                    erg = max(vline,posmax)
                    bb(l,kk) = abs(posmax-posmin)                    
                    if posmin lt posmax then polarity(l,kk) = 1 else polarity(l,kk) = -1
                    erg = max(abs(vline))
                    if erg lt pollimit then begin
                        polarity(l,kk) = 0
                        bb(l,kk) = 0
                    endif

                 endfor
             endif else begin

                for kkk = 0,n_slits -1 do begin

                   ii = reform(i(kkk,*,*))
                   qq = reform(q(kkk,*,*))
                   uu = reform(u(kkk,*,*))
                   vv = reform(v(kkk,*,*))
              
                   

                 ; loop along slit
                for kk = 0,tt(2)-1 do begin
                    iline = smooth(float(ii(*,kk)),5)

                    erg = min(iline(line48(0):line48(1)),posmin)
                    posmin = posmin+line48(0)
                    if posmin lt 3 then posmin = 3

                    lpff,iline(posmin-3:posmin+3),pos48
                    pos48 = pos48+posmin-3
                
                
                    erg = min(iline(line52(0):line52(1)),posmin)
                    posmin = posmin+line52(0)
                    if posmin lt 3 then posmin = 3

                    lpff,iline(posmin-3:posmin+3),pos52
                    pos52 = pos52+posmin-3
                   
                    v52(l+kkk*tt(1)/n_slits,kk) = pos52
                    v48(l+kkk*tt(1)/n_slits,kk) = pos48
                    
                    coremap(l+kkk*tt(1)/n_slits,kk) = total(iline(posmin-3:posmin+3));iline(posmin-30)-total(iline(posmin-3:posmin+3))/7.


; determine polarity and polarization degree in Stokes V
                    vline = vv(line48(0):line48(1),kk)/float(ii(line48(0):line48(1),kk))
                    
                    
                   
                    erg = min(vline,posmin)
                    erg = max(vline,posmax)
                    bb(l+kkk*tt(1)/n_slits,kk) = abs(posmax-posmin)                    
                    if posmin lt posmax then polarity(l+kkk*tt(1)/n_slits,kk) = 1 else polarity(l+kkk*tt(1)/n_slits,kk) = -1
                    erg = max(abs(vline))
                    if erg lt pollimit then begin
                        polarity(l+kkk*tt(1)/n_slits,kk) = 0
                        bb(l+kkk*tt(1)/n_slits,kk) = 0
                    endif

                 endfor

             endfor

             endelse




                if n_elements(fast) eq 0 then begin
                   wset,0
                   tvscl,v52-mean(v52(where(v52 ne 0))) <5 >(-5),0,tt(2)
                   tvscl,polarity >(-500) <500.,tt(1),tt(2)
                endif else begin
                   print,tt(1)-l,cr,form='(A,a1,$)'
                endelse

             endfor

; save velocity and polarity maps
            if n_elements(change_save) eq 0 then  save,v52,v48,bb,polarity,coremap,filename = inpath+files1(k)+'.velpol.sav' else save,v52,v48,bb,polarity,coremap,filename = change_save+files1(k)+'.velpol.sav'

         endif



        if n_elements(change_save) eq 0 then restore,inpath+files1(k)+'.velpol.sav' else restore,change_save+files1(k)+'.velpol.sav'

        ic = smooth(ic,wwidth)


        polarity = smooth(polarity,wwidth)
        fff = where(finite(v52) ne 1)
        if fff(0) ne -1 then v52(fff) = 0.
        fff = where(finite(v48) ne 1)
        if fff(0) ne -1 then v48(fff) = 0.

        v48 = smooth(v48,wwidth)
        v52 = smooth(v52,wwidth)
        bb = smooth(bb,wwidth)
        coremap = smooth(coremap,wwidth)

           
        toti = ic

        if n_elements(wavelen) ne 0 then begin
           if wavelen eq 1083 then bb = alog(coremap >0.0001)
        endif

        ff = size(toti)
        
        v52 = v52-mean(v52(where(v52 ne 0 and finite(v52) eq 1) ))
        v48 = v48-mean(v48(where(v48 ne 0 and finite(v48) eq 1) ))


        totv = smooth(alog(totv > 0.001 < 10 ),wwidth)
        totq =  smooth(alog(totq > 0.001 < 10),wwidth)
        totu =  smooth(alog(totu > 0.001 < 10),wwidth)
            
        if stepwidth eq 0. or stepwidth eq 'nonumber' then stepwidth =1. 
            
        xxx = ff(1) *stepwidth /sampl    ;*stepwidth  ;/sampl
        xxx = xxx(0)

        yyy = ff(2)  ;
        yyy = yyy(0)

        v48 = congrid(v48,xxx,yyy,/interp)
        v52 = congrid(v52,xxx,yyy,/interp) ;ff(1)*2,ff(2)*2*sampl/stepwidth
        bb  = congrid(bb,xxx,yyy,/interp)

; create ps file with original resolution
        outfile = outpath+files1(k)+'.ps'

       if n_elements(ps) ne 0 then begin
            
       scale = 10
       set_plot,'PS'
       device,filename = outfile,xsize=4.*ff(1)/100.*stepwidth/sampl*scale/10.,ysize = ff(2)/100.*2*scale/10.,bits_per_pixel = 8,/color
            loadct,0,/silent
            
           tvscl,toti,0,0,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device 
            tvscl,totq< (-4) ,ff(1)*stepwidth/sampl*scale,0,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device
            tvscl,totu < (-4),ff(1)*stepwidth/sampl*2*scale,0,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device
            tvscl,totv< (-4)  ,ff(1)*stepwidth/sampl*3*scale,0,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device

            tvscl,v48 <5 >(-5),0,ff(2)*scale,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device
            tvscl,v52 <5 >(-5),ff(1)*stepwidth/sampl*1*scale,ff(2)*scale,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device
            loadct,13,/silent
            tvscl,bb,ff(1)*stepwidth/sampl*2*scale,ff(2)*scale,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device
            loadct,0,/silent
            tvscl,polarity <200 >(-200),ff(1)*stepwidth/sampl*3*scale,ff(2)*scale,xsize=ff(1)*stepwidth/sampl*scale,ysize = ff(2)*scale,/device

            xyouts,.01,.01,'I',charsize=1.5,charthick = 1.5,/normal,color=255
            xyouts,.26,.01,'Q',charsize=1.5,charthick = 1.5,/normal,color=255
            xyouts,.51,.01,'U',charsize=1.5,charthick = 1.5,/normal,color=255
            xyouts,.76,.01,'V',charsize=1.5,charthick = 1.5,/normal,color=255

  if wavelen gt 15000. then begin
                xyouts,.01,.51,'1564.8',charsize=1.5,charthick = 1.5,/normal,color=255
                xyouts,.26,.51,'1565.2',charsize=1.5,charthick = 1.5,/normal,color=255
            endif

            if wavelen gt 10000./10. and wavelen lt 15000./10. then begin
                xyouts,.01,.51,'Si1082',charsize=1.5,charthick = 1.5,/normal,color=255
                xyouts,.26,.51,'He1083',charsize=1.5,charthick = 1.5,/normal,color=255
               
             endif

    if wavelen eq 630. then begin
                xyouts,.01,.51,'Fe630.15',charsize=1.5,charthick = 1.5,/normal,color=255
                xyouts,.26,.51,'Fe630.25',charsize=1.5,charthick = 1.5,/normal,color=255
               
             endif

            btext = 'B'
            
            if n_elements(wavelen) ne 0 then begin
               if wavelen eq 1083 then btext = 'I_core'        
            endif

            xyouts,.51,.51,btext,charsize=1.5,charthick = 1.5,/normal,color=255
            loadct,39,/silent
            xyouts,.76,.51,'Polarity',charsize=1.5,charthick = 1.5,/normal,color=240
            
            loadct,0,/silent
            
            cchars = 1.
            for jj = 0,3 do begin
                if jj gt 0 then  ychars = .001 else ychars = 1

                plot,findgen(5),fltarr(5),position = [.25*jj,0,.25*(jj+1),.5],/noerase,xrange= [0,ff(1)*stepwidth]*.725,/xstyle,yrange= [0,ff(2)*sampl]*.725,/ystyle,ycharsize = ychars,charsize = cchars;,xtitle = 'Mm',ytitle = 'Mm'
                plot,findgen(5),fltarr(5),position = [.25*jj,0.5,.25*(jj+1),1],/noerase,xrange= [0,ff(1)*stepwidth]*.725,/xstyle,yrange= [0,ff(2)*sampl]*.725,/ystyle,xcharsize = .001,ycharsize = ychars,charsize = cchars;,xtitle = 'Mm',ytitle = 'Mm'
            endfor

            device,/close
            set_plot,'X'
         endif




; create gif file

       sscale = 1.
       if n_elements(twice) ne 0 then sscale = sscale/float(twice)
       
       eerg = get_screen_size()
       xdimmax = eerg(0)-100.
       ydimmax = eerg(1)-100.
       sscalex = sscale
       sscaley = sscale
   
       if ff(2)/2./sscaley gt ydimmax then begin
          sscaley = sscaley*1.5
          sscalex = sscalex*1.5
       endif
 
       if 4.*ff(1)*stepwidth/sampl/4./sscalex gt xdimmax then begin
               
          while 4.*ff(1)*stepwidth/sampl/4./sscalex gt xdimmax   do begin
             sscalex = sscalex * 1.25
             sscaley = sscaley * 1.25
          endwhile
       endif
            
       xxs =  4.*ff(1)*stepwidth/sampl/4./sscalex
       xxs = xxs(0)
       yys = ff(2)/2./sscaley
       yys = yys(0)  ;*12.

       window,0,xsize =xxs ,ysize = yys
       scale = 1
       loadct,0,/silent
       device,decomposed = 0
     
       ;tvscl,congrid(toti ,xxs/4.,yys/2.,/interp),0,0
       ;tvscl,congrid(totq,xxs/4.,yys/2.,/interp),xxs/4.,0;ff(1)*stepwidth/sampl/4./sscalex,0
;       tvscl,congrid(totu,xxs/4.,yys/2.,/interp),xxs/4.*2.,0 ;,ff(1)*stepwidth/sampl/4.*2/sscalex,0
 ;      tvscl,congrid(totv,xxs/4.,yys/2.,/interp),xxs/4.*3.,0; ,ff(1)*stepwidth/sampl/4.*3/sscalex,0

  ;     tvscl,congrid(v48,xxs/4.,yys/2.,/interp) <5 >(-5),0, yys/2.;ff(2)/4./sscaley
   ;    tvscl,congrid(v52,xxs/4.,yys/2.,/interp) <10 >(-10), xxs/4.,yys/2.  ;ff(1)*stepwidth/sampl/4./sscalex*1,ff(2)/4./sscaley
    ;   loadct,0,/silent
     ;  tvscl,congrid(bb,xxs/4.,yys/2.,/interp),  xxs/4.*2,yys/2.  ;ff(1)*stepwidth/sampl/4./sscalex*2,ff(2)/4./sscaley

       tvscl,congrid(toti ,xxs/4.,yys/2.,/interp),0,0
       tvscl,congrid(totq,xxs/4.,yys/2.,/interp) ,ff(1)*stepwidth/sampl/4./sscalex,0
       tvscl,congrid(totu,xxs/4.,yys/2.,/interp) ,ff(1)*stepwidth/sampl/4.*2/sscalex,0
       tvscl,congrid(totv,xxs/4.,yys/2.,/interp) ,ff(1)*stepwidth/sampl/4.*3/sscalex,0

       tvscl,congrid(v48,xxs/4.,yys/2.,/interp) <5 >(-5),0,ff(2)/4./sscaley
       tvscl,congrid(v52,xxs/4.,yys/2.,/interp) <10 >(-10),ff(1)*stepwidth/sampl/4./sscalex*1,ff(2)/4./sscaley
       loadct,0,/silent
       tvscl,congrid(bb,xxs/4.,yys/2.,/interp),ff(1)*stepwidth/sampl/4./sscalex*2,ff(2)/4./sscaley
       loadct,0,/silent
       tvscl,congrid(polarity,xxs/4.,yys/2.,/interp) <200 >(-200),ff(1)*stepwidth/sampl/4./sscalex*3,ff(2)/4./sscaley

       xyouts,.01,.01,'I',charsize=1.5,charthick = 1.5,/normal,color=255
       xyouts,.26,.01,'Q',charsize=1.5,charthick = 1.5,/normal,color=255
       xyouts,.51,.01,'U',charsize=1.5,charthick = 1.5,/normal,color=255
       xyouts,.76,.01,'V',charsize=1.5,charthick = 1.5,/normal,color=255
       
       if wavelen gt 15000. then begin
               xyouts,.01,.51,'1564.8',charsize=1.5,charthick = 1.5,/normal,color=255
               xyouts,.26,.51,'1565.2',charsize=1.5,charthick = 1.5,/normal,color=255
            endif
       if wavelen gt 10000./10. and wavelen lt 15000./10. then begin
          xyouts,.01,.51,'Si1082',charsize=1.5,charthick = 1.5,/normal,color=255
          xyouts,.26,.51,'He1083',charsize=1.5,charthick = 1.5,/normal,color=255
       endif

       if wavelen eq 630 then begin
          xyouts,.01,.51,'Fe630.15',charsize=1.5,charthick = 1.5,/normal,color=255
          xyouts,.26,.51,'Fe630.25',charsize=1.5,charthick = 1.5,/normal,color=255
       endif

       btext = 'B'
            
       if n_elements(wavelen) ne 0 then begin
          if wavelen eq 1083 then btext = 'I_core'        
       endif

       xyouts,.51,.51,btext,charsize=1.5,charthick = 1.5,/normal,color=255
       loadct,39,/silent
       xyouts,.76,.51,'Polarity',charsize=1.5,charthick = 1.5,/normal,color=240
            
       loadct,0,/silent
            
       for jj = 0,3 do begin
          if jj gt 0 then  ychars = .001 else ychars = 1
                
          plot,findgen(5),fltarr(5),position = [.25*jj,0,.25*(jj+1),.5],/noerase,xrange= [0,ff(1)*stepwidth]*.725,/xstyle,yrange= [0,ff(2)*sampl]*.725,/ystyle,ycharsize = ychars
          plot,findgen(5),fltarr(5),position = [.25*jj,0.5,.25*(jj+1),1],/noerase,xrange= [0,ff(1)*stepwidth]*.725,/xstyle,yrange= [0,ff(2)*sampl]*.725,/ystyle,xcharsize = .001,ycharsize = ychars
       endfor
       out_gif = outpath+files1(k)+'.gif'
       a = tvrd()
       write_gif,out_gif,a   
nextfile:
    endfor



 end





