;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;+
; NAME: ibis_tmxt.pro
;       
;
; PURPOSE: Calculate T-matrix for Dunn Solar Telescope
;
; CATEGORY:
;
; CALLING SEQUENCE:
;       
; ibis_tmtx, tparams, lambda, tp_azim, tp_elev, tp_table
;
; INPUTS: tparams, lambda, tp_azim, tp_elev, tp_table
;
; KEYWORD PARAMETERS: none
;
; OUTPUTS: 4x4 Mueller matrix of telescope
;       
;
; OPTIONAL OUTPUTS:
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;
;-
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
FUNCTION ibis_tmtx, tparams, lambda1, tp_azim, tp_elev, tp_table

;;-------------------------------
;; Calculate T-Matrix
;;-------------------------------

      geometry = [tp_azim, tp_elev, tp_table]

      ttt = tparams
      s = size(ttt)  

      if s[1] eq 68 then CONSTRUCTTMATRIX_NEW, ttt, geometry, lambda1, tmtx, /nonorm

      if s[1] eq 28 then CONSTRUCTTMATRIX, ttt, geometry, lambda1, tmtx, /nonorm


;      print,'****************************************'
;      print, 'DST Mueller matrix : ', tmtx/tmtx[0,0]
;      print,'****************************************'

      ttt = 0.

;;***************************************************************
;; Done
;;***************************************************************

RETURN, tmtx
END
