function length,x

;+
;============================================================================
;
;	function : length
;
;	purpose  : return length of vector
;
;       calls    : size.pro (idl-implemented)
;
;	written :  cbeck@KIS 06/02
;
;==============================================================================
;
;	Check number of arguments.
;
;==============================================================================
if (n_params() lt 1) then begin
	print
	print, "usage:  N = length(x)"
	print
        print, "        Return length of 1-dimensional vector."
        print
	print, "	Arguments"
        print, "                Input :"
        print, "		x : vector"
        print
        print, "                Output:"
        print, "                N = number of entries"
return,0
endif
;==============================================================================
;-

a = size(x)
N = float(a(1))
return,N
end

