pro window_pos,image,winindex=winindex,no_del = no_del,true = true,value = value,pos = pos

;+
;============================================================================
;
;	procedure : window_pos
;
;	purpose  : return coordinates in 2-d array
;
;	written :  cbeck@KIS 03/04
;
;==============================================================================
;
;	Check number of arguments.
;
;==============================================================================
if (n_params() lt 1) then begin
	print
	print, "usage:  window_pos,image,winindex = winindex,no_del = no_del"
	print
	print, "	Display 2-d array in window, print cursor"
        print, "        position, give position on terminal if"
        print, "        left mouse button is pressed. Right"
        print, "        mouse button finishes."
        print
	print, "	Arguments"
        print, "                Input :"
        print, "		image: 2-d array"
        print
        print, "        Keywords:"
        print, "                windex : number of window, default: 0"
        print, "                no_del : keep window"
        print
        return
endif
;==============================================================================
;-

image = reform(image)

tt = size(image)

if n_elements(tt) lt 4 then begin
print,' Sorry, this seems to be no 2-d array.'
print,' Size is: ',tt
print,' ! Aborting window_pos.'
return
endif

if n_elements(true) ne 0 then begin
tt(1) = tt(2)
tt(2) = tt(3)
endif


if n_elements(winindex) eq 0 then windex = 0 else windex = winindex

window,windex,xsize=tt(1),ysize=tt(2)
tvscl,image,true = true
finished = 0
while finished ne 1 do begin
wset,windex
cursor,x,y,/device,/change

if x gt tt(1)-1 then  x = tt(1)-1
if y gt tt(2)-1 then  y = tt(2)-1

tvscl,image,true = true
plots,[x,x],[0,tt(2)-1],/device
plots,[0,tt(1)-1],[y,y],/device
xyouts,.5,.35,num2string(x)+','+num2string(y),/normal,charsize=2

;if n_elements(true) ne 0 then begin
;print,[image(0,x,y),image(1,x,y),image(2,x,y)]
;endif
if n_elements(value) ne 0 then begin
print,'Image value at '+num2string(fix(x))+','+num2string(fix(y))+' : ',image(x,y)
endif


if !mouse.button eq 1 then begin 
print,x,y
wait,.1
endif
if !mouse.button eq 4 then begin
finished = 1
pos = [x,y]
endif


endwhile

if n_elements(no_del) eq 0 then wdelete,windex

end
